#pragma once

#include "TaMaterial.h"
#include "TaAnimValues.h"

/**
\file TaObject.h
\brief IuWFNg NX`Ă܂B
*/

/**
\ingroup ClassGroup
\brief IuWFNg NX
*/
class CTaObject
{
	///RXgN^(gps)
	/**
	RXgN^gpĂ͂܂B
	CX^X̍쐬ɂ TaCreateObject() 𗘗pĂB
	*/
	CTaObject(){}

	///fXgN^(gps)
	/**
	fXgN^gpĂ͂܂B
	CX^X̍폜ɂ TaDeleteObject() 𗘗pĂB
	*/
	~CTaObject(){}

public:

	///IuWFNg̃^Cv̎擾
	/**
	\return ^Cv
	*/
	TA_OBJECT_TYPE GetType()const;

	///IuWFNg̃^Cv̎擾
	/**
	\return IuWFNg̃^Cv
	*/
	LPCTSTR GetTypeName()const;

	///O̎擾
	/**
	\return IuWFNg̖O
	*/
	LPCTSTR GetName()const;

	///ÕZbg
	/**
	\param pszName IuWFNg̖O
	*/
	void SetName(LPCTSTR pszName);

	///Kw̒擾
	/**
	Kw̃oCg擾܂B
	\return ̒
	*/
	UINT GetTreeNameLength()const;

	///Kw擾
	/**
	[g̊Kw擾܂B
	\param pszTreeName pobt@[
	*/
	void GetTreeName(LPTSTR pszTreeName)const;

	///IuWFNg̕\Ԃ̎擾
	/**
	\return \
	*/
	BOOL GetVisible()const;

	///IuWFNg̕\Ԃ̃Zbg
	/**
	\param bVisible \
	\param bUpdateGraphics TRUȄꍇA̍Ō UpdateGraphics() s܂B
	*/
	void SetVisible(BOOL bVisible, BOOL bUpdateGraphics = FALSE);

	///IuWFNg̕ҏWsԂ̎擾
	/**
	\return ҏWs
	*/
	BOOL GetLocked()const;

	///IuWFNg̕ҏWsԂ̃Zbg
	/**
	\param bLocked ҏWs
	*/
	void SetLocked(BOOL bLocked);

	///Aj[V̉]ŋʐ`Ԃ邩ǂ̏Ԃ擾
	/**
	\return ʐ`Ԃ邩ǂB
	*/
	BOOL GetSlerped()const;

	///Aj[V̉]ŋʐ`Ԃ邩ǂ̏ԂZbg
	/**
	\param bSlerped ʐ`Ԃ邩ǂB
	*/
	void SetSlerped(BOOL bSlerped);

	///ʂ̊pxŃX[Y^tbg VF[fBOݒ肳邩ǂ擾
	/**
	̐ݒɉ UpdateMeshNormals() ̋ω܂B
	\return ʂ̊pxŃX[Y^tbg VF[fBOݒ肳邩ǂB
	*/
	BOOL GetAngularShaded();

	///ʂ̊pxŃX[Y^tbg VF[fBOݒ肳邩ǂZbg
	/**
	̐ݒɉ UpdateMeshNormals() ̋ω܂B
	\param bAngularShaded ʂ̊pxŃX[Y^tbg VF[fBOݒ肳邩ǂB
	\param bUpdateGeometry TRUȄꍇA̍Ō UpdateMeshNormals()  UpdateGeometry() s܂B
	*/
	void SetAngularShaded(BOOL bAngularShaded, BOOL bUpdateGeometry = FALSE);

	///X[Y VF[fBOő̖ʂ̊px擾
	/**
	\return X[Y VF[fBOő̖ʂ̊pxB
	*/
	float GetSmoothAngle();

	///X[Y VF[fBOő̖ʂ̊pxZbg
	/**
	\param SmoothAngle X[Y VF[fBOő̖ʂ̊pxB
	\param bUpdateGeometry TRUȄꍇA̍Ō UpdateMeshNormals()  UpdateGeometry() s܂B
	*/
	void SetSmoothAngle(float SmoothAngle, BOOL bUpdateGeometry = FALSE);

	///IC[p̉]̎擾
	/**
	return ]
	*/
	TA_EULER_ORDER_TYPE GetEulerOrder()const;

	///IC[p̉]̃Zbg
	/**
	\param EulerOrder ]
	*/
	void SetEulerOrder(TA_EULER_ORDER_TYPE EulerOrder);

	///s{bg̎擾
	/**
	\return s{bg
	*/
	TA_VECTOR GetPivot()const;

	///s{bg̃Zbg
	/**
	\param Pivot s{bg
	*/
	void SetPivot(const TA_VECTOR& Pivot);

	///XP[̎擾
	/**
	\return XP[
	*/
	TA_VECTOR GetScale()const;

	///XP[̃Zbg
	/**
	\param Scale XP[
	*/
	void SetScale(const TA_VECTOR& Scale);

	///f̎擾
	/**
	XY(YXɈ)AXZ(ZXɈ)AYZ(ZYɈ)̊el̃xNgB
	\return f
	*/
	TA_VECTOR GetShear()const;

	///f̃Zbg
	/**
	XY(YXɈ)AXZ(ZXɈ)AYZ(ZYɈ)̊el̃xNgB
	\param Shear f
	*/
	void SetShear(const TA_VECTOR& Shear);

	///]NH[^jI̎擾
	/**
	\return NH[^jI
	*/
	TA_QUAT GetRotate()const;

	///]NH[^jĨZbg
	/**
	IC[p͍XV܂B
	\param Rotate NH[^jI
	\param bResetAngle IC[pZbgꍇTRUEÃ݂IC[pɋ߂lZbgꍇFALSEB
	*/
	void SetRotate(const TA_QUAT& Rotate, BOOL bResetAngle = TRUE);

	///IC[p̎擾
	/**
	\return IC[p
	*/
	TA_VECTOR GetAngle()const;

	///IC[p̃Zbg
	/**
	]Ɉˑ܂BNH[^jI͍XV܂B
	\param Angle IC[p
	*/
	void SetAngle(const TA_VECTOR& Angle);

	///ړ̎擾
	/**
	\return ړ
	*/
	TA_VECTOR GetTranslate()const;

	///ړ̃Zbg
	/**
	\param Translate ړ
	*/
	void SetTranslate(const TA_VECTOR& Translate);

	///ϊs̎擾
	/**
	[JϊsZoA擾܂B
	\param Transform IuWFNg̈ړA]AXP[Af܂ޕϊsB
	\param bLeftHand Wn(Z])̍s擾ꍇTRUEB
	*/
	void GetTransform(TA_MATRIX& Transform, BOOL bLeftHand = FALSE)const;

	///ϊs̃Zbg
	/**
	[Jϊs񂩂A
	IuWFNg̈ړA]AXP[Af̃p[^ZočXV܂B̊֐ɂA
	GetPivot() ̒l(0,0,0)ɂȂA GetJointParentScaleCompensated() ̒lFALSEɂȂ܂B 
	\param Transform IuWFNg̈ړA]AXP[Af܂ޕϊsB
	\param bShear fZoꍇTRUEBFALSȄꍇAf(0,0,0)ɂȂ܂B
	\param bLeftHand Wn(Z])̍s̏ꍇTRUEB
	*/
	void SetTransform(const TA_MATRIX& Transform, BOOL bShear = FALSE, BOOL bLeftHand = FALSE);

	///[hϊs̎擾
	/**
	IuWFNg̊KŵڂāA[hϊsZo܂B
	\param Transform IuWFNg̈ړA]AXP[Af܂ޕϊsB
	\param bLeftHand Wn(Z])̍s擾ꍇTRUEB
	*/
	void GetWorldTransform(TA_MATRIX& Transform, BOOL bLeftHand = FALSE)const;

	///{[̎擾
	/**
	\return IuWFNgɃZbgĂ{[B
	*/
	UINT GetBoneCount()const;

	///{[ Xg̎擾
	/**
	\param pBones {[̃Xg
	\return 擾łꍇTRUEB
	*/
	BOOL GetBones(CTaObject* pBones[])const;

	///{[ Xg̃Zbg
	/**
	\param pBones {[̃Xg
	\param nCount {[̐
	*/
	void SetBones(CTaObject*const pBones[], UINT nCount);

	///XL̃oChϊs̎擾
	/**
	\param Transform oCh |[YɂXL̃[hϊs
	\return 擾łꍇTRUEB
	*/
	BOOL GetSkinBindTransform(TA_MATRIX& Transform)const;

	///XL̃oChϊs̃Zbg
	/**
	\param Transform oCh |[YɂXL̃[hϊs
	*/
	void SetSkinBindTransform(const TA_MATRIX& Transform);

	///{[̃oChϊs񃊃Xg̎擾
	/**
	\param Transforms oCh |[Yɂ{[̃[hϊs񃊃Xg
	*/
	BOOL GetBoneBindTransforms(TA_MATRIX Transforms[])const;

	///{[̃oChϊs񃊃Xg̃Zbg
	/**
	\param Transforms oCh |[Yɂ{[̃[hϊs񃊃Xg
	\param nCount Xg̗vf
	*/
	void SetBoneBindTransforms(const TA_MATRIX Transforms[], UINT nCount);

	///oCh |[Y̗vf擾
	/**
	\return  oCh |[Y̗vf
	*/
	UINT GetBindPoseObjectCount()const;

	///oCh |[Y擾
	/**
	oCh |[Ył̃XLA{[т̑SĂ̐eIuWFNg܂ރXgłB
	\param pObjects IuWFNg̃Xg
	\param Translates ړ̃Xg
	\param Angles IC[p̃Xg
	\param Scales XP[̃Xg
	\param Shears f̃Xg
	\return 擾łꍇTRUEB
	*/
	BOOL GetBindPose(CTaObject* pObjects[], TA_VECTOR Translates[],
										TA_VECTOR Angles[], TA_VECTOR Scales[], TA_VECTOR Shears[])const;

	///oCh |[YZbg
	/**
	oCh |[Ył̃XLA{[т̑SĂ̐eIuWFNg܂ރXgłB
	\param pObjects IuWFNg̃Xg
	\param Translates ړ̃Xg
	\param Angles IC[p̃Xg
	\param Scales XP[̃Xg
	\param Shears f̃Xg
	\param nCount oCh|[Y̗vf
	*/
	void SetBindPose(CTaObject*const pObjects[], const TA_VECTOR Translates[],
										const TA_VECTOR Angles[], const TA_VECTOR Scales[], const TA_VECTOR Shears[], UINT nCount);

	///{[֘ÃNA
	/**
	SẴ{[֘ANA܂B
	_̃{[ CfbNXAEFCgNA܂B
	*/
	void ClearBones();

	///eIuWFNg̎擾
	/**
	\return eIuWFNg
	*/
	CTaObject* GetParent()const;

	///[g f擾
	/**
	eIuWFNĝڂāA[g f擾܂B
	\return #TA_OBJECT_MODEL ^CṽIuWFNg
	*/
	CTaObject* GetRootModel()const;

	///qIuWFNg̎擾
	/**
	\return qIuWFNg
	*/
	UINT GetChildCount()const;

	///CfbNX̎qIuWFNg̎擾
	/**
	\param nIndex CfbNX
	\return qIuWFNg
	*/
	CTaObject* GetChild(UINT nIndex)const;

	///qIuWFNg̃CfbNXʒu擾
	/**
	\param pChild qIuWFNg
	\return CfbNX
	*/
	UINT GetChildIndex(const CTaObject* pChild)const; 

	///qIuWFNgǉ
	/**
	\param pChild qIuWFNg
	*/
	void AddChild(CTaObject* pChild);

	///qIuWFNgCfbNXʒuɑ}
	/**
	\param nIndex CfbNX
	\param pChild qIuWFNg
	\return ꍇTRUEB
	*/
	BOOL InsertChild(UINT nIndex, CTaObject* pChild);

	///qIuWFNg菜
	/**
	qIuWFNĝ͍폜܂B
	\param pChild qIuWFNg
	\return ꍇTRUEB
	*/
	BOOL RemoveChild(CTaObject* pChild);

	///qIuWFNg폜
	/**
	\param pChild qIuWFNg
	\return ꍇTRUEB
	*/
	BOOL DeleteChild(CTaObject* pChild);

	///[g̃CfbNX Xg̃TCY擾
	/**
	[g f́AqIuWFNg̃CfbNX Xg̗vf擾܂B
	\return CfbNX Xg̗vfB
	*/
	UINT GetIndexCount()const;

	///[g̃CfbNX Xg擾
	/**
	[g f́AqIuWFNg̃CfbNX Xg擾܂B
	\param Indices CfbNX Xg
	\return CfbNX Xg̗vf
	*/
	UINT GetIndices(UINT Indices[])const;

	///CfbNX Xg̃IuWFNǧ
	/**
	̃IuWFNgAq̃CfbNX XgŎw肳IuWFNg擾܂B
	Xg̏ꍇÃIuWFNĝԂ܂B
	\param Indices CfbNX Xg
	\param nCount CfbNX Xg̗vf
	\return IuWFNg
	*/
	CTaObject* Find(const UINT Indices[], UINT nCount)const;

	///CfbNX XgʒuɃIuWFNg}
	/**
	\param Indices CfbNXXg
	\param nCount CfbNXXg̗vf
	\param pObject IuWFNg
	\return ꍇTRUEB
	*/
	BOOL Insert(const UINT Indices[], UINT nCount, CTaObject* pObject);

	///Kw̃IuWFNǧ
	/**
	̃IuWFNgAKwŎw肳IuWFNg擾܂B
	Kw̐擪͂̃IuWFNg̖OłKv܂B
	\param pszTreeName Kw
	\return IuWFNg
	*/
	CTaObject* FindTreeName(LPCTSTR pszTreeName)const;

	///_̎擾
	/**
	\return _
	*/
	UINT GetVertexCount()const;

	///_̈ʒuXg̎擾
	/**
	\param Positions _̈ʒuXg
	*/
	void GetVertexPositions(TA_VECTOR Positions[])const;

	///_̈ʒuXg̃Zbg
	/**
	\param Positions _̈ʒuXg
	*/
	void SetVertexPositions(const TA_VECTOR Positions[]);

	///_̒ǉ
	/**
	\param Position _̈ʒu
	*/
	void AddVertex(const TA_VECTOR& Position);

	///_̒ǉ
	/**
	\param Positions _̈ʒuXg
	\param nCount vf
	*/
	void AddVertices(const TA_VECTOR Positions[], UINT nCount);

	///_{[ f[^܂ނǂ
	/**
	\return ܂ޏꍇTRUEB
	*/
	BOOL HasVertexBone()const;

	///_̃{[ f[^擾
	/**
	_#TA_MAX_VERTEX_BONE_COUNT̃EFCgS0łꍇ̂A
	EFCg̍v1ƂȂ܂B
	\param pIndices _Ƃ#TA_MAX_VERTEX_BONE_COUNT̃{[ CfbNX̔z
	\param pWeights _Ƃ#TA_MAX_VERTEX_BONE_COUNT̃{[ EFCgz
	\return 擾łꍇTRUEB
	*/
	BOOL GetVertexBones(BYTE*const pIndices[], float*const pWeights[])const;

	///_̃{[ f[^Zbg
	/**
	_#TA_MAX_VERTEX_BONE_COUNT̃EFCgS0łꍇ̂A
	EFCg̍v1łKv܂B
	\param pIndices _Ƃ#TA_MAX_VERTEX_BONE_COUNT̃{[ CfbNX̔z
	\param pWeights _Ƃ#TA_MAX_VERTEX_BONE_COUNT̃{[ EFCgz
	\return ꍇTRUEB
	*/
	BOOL SetVertexBones(const BYTE*const pIndices[], const float*const pWeights[]);

	///ʐ̎擾
	/**
	\return ʂ̐
	*/
	UINT GetFaceCount()const;

	///ʂ̒_Xg̎擾
	/**
	\param Counts ʂ̒_̃Xg
	*/
	void GetFaceVertexCounts(UINT Counts[])const;

	///ʂ̒_CfbNX Xg̎擾
	/**
	\param pIndices ʂƂ̒_CfbNX̔z
	*/
	void GetFaceVertexIndices(int*const pIndices[])const;

	///ʂ̃}eA Xg̎擾
	/**
	\param pMaterials ʂ̃}eÃXg
	*/
	void GetFaceMaterials(CTaMaterial* pMaterials[])const;

	///ʂ̃}eA Xg̃Zbg
	/**
	\param pMaterials ʂ̃}eÃXg
	*/
	void SetFaceMaterials(CTaMaterial*const pMaterials[]);

	///ʂ̖@xNg Xg̎擾
	/**
	\param Normals ʂ̖@xNg̃Xg
	*/
	void GetFaceNormals(TA_VECTOR Normals[])const;

	///ʂ̒_̃tbg VF[fBO tO Xg̎擾
	/**
	\param pFlatShades ʂƃtbg VF[fBO tÕXg
	*/
	void GetFaceVertexFlatShades(BOOL*const pFlatShades[])const;

	///ʂ̒_̃tbg VF[fBO tO Xg̃Zbg
	/**
	\param pFlatShades ʂƂ̃tbg VF[fBO tÕXg
	*/
	void SetFaceVertexFlatShades(const BOOL*const pFlatShades[]);

	///ʂ̒_J[ Xg̎擾
	/**
	\param pColors ʂƂ̒_J[̔z
	*/
	void GetFaceVertexColors(TA_COLOR*const pColors[])const;

	///ʂ̒_J[ Xg̃Zbg
	/**
	\param pColors ʂƂ̒_J[̔z
	*/
	void SetFaceVertexColors(const TA_COLOR*const pColors[]);

	///ʂLUVlĂ邩
	/**
	\return LȒlꍇTRUEB
	*/
	BOOL HasFaceVertexUV()const;

	///ʂ̒_UVXg̎擾
	/**
	\param pUVs ʂ̒_ƂUVWXg
	*/
	void GetFaceVertexUVs(TA_VECTOR_2D*const pUVs[])const;

	///ʂ̒_UVXg̃Zbg
	/**
	\param pUVs ʂ̒_ƂUVWXg
	*/
	void SetFaceVertexUVs(const TA_VECTOR_2D*const pUVs[]);

	///ʂ̒_̖@xNg Xg̎擾
	/**
	\param pNormals ʂ̒_ƂUVWXg
	*/
	void GetFaceVertexNormals(TA_VECTOR*const pNormals[])const;

	///ʂ̒ǉ
	/**
	\param Indices _CfbNX̃Xg
	\param nCount Xg̗vf
	*/
	void AddFace(const int Indices[], UINT nCount);

	///̖ʂ̒ǉ
	/**
	\param pIndices ʂƂ̒_CfbNX̃Xg
	\param Counts ʂƂ̒_
	\param nCount ǉʂ̐
	*/
	void AddFaces(const int*const pIndices[], const UINT Counts[], UINT nCount);

	///bV̕sȖʂⒸ_̃N[Abv
	/**
	_̑ȂsȖʂASQƂĂȂsvȒ_Ȃǂ폜܂B
	*/
	void CleanUpMesh();

	///bV̐ڑ֌W̍XV
	/**
	ʂ̐ڑ֌WXV܂B
	ʂǉ/폜ꍇAK̊֐ĂяoKv܂B
	*/
	void UpdateMeshTopology();

	///bV̖@xNg̍XV
	/**
	ʂ̖@xNgAʂ̒_̒_̖@xNgXV܂B
	ʂǉ^폜ꍇA_ʒuʂ̒_̃tbg VF[fBO
	tOύXꍇAK̊֐ĂяoKv܂B
	GetAngularShaded() FALSȄꍇAʂ̒_̃tbg VF[fBO tOɉ
	_̖@xNgXV܂BTRUȄꍇAʂ̒_̃tbg VF[fBO
	tÔ GetSmoothAngle() ̒lɉčXVĂA
	_̖@xNgXV܂B
	*/
	void UpdateMeshNormals();

	///oEfBO {bNX̍XV
	/**
	SĂ̒_悤ɁAoEfBO {bNXXV܂B
	ʂǉ/폜ꍇⒸ_ʒuύXꍇAK̊֐ĂяoKv܂B
	*/
	void UpdateBoundBox();

	///OtBbNX̍XV
	/**
	`pDirect3D|S f[^XV܂B
	IuWFNg̍쐬A{[ݒύXꍇAʂǉ/폜ꍇȂǂɂāA
	K̊֐ŌɌĂяoKv܂BJ ^Cv(#TA_OBJECT_CAMERA)A
	Cg ^Cv(#TA_OBJECT_LIGHT)̃p[^ύXꍇɂĂяoKv܂B
	WCg ^Cv(#TA_OBJECT_JOINT)̏ꍇA
	qWCgeWCg̏ɌĂяoKv܂B
	*/
	void UpdateGraphics();

	///WIg̍XV
	/**
	`pDirect3D|S f[^̒_ʒuXV܂B
	_ʒûݕύXꍇA
	K̊֐ŌɌĂяoKv܂B
	*/
	void UpdateGeometry();

/**
\anchor JointMethod
\name WCgp\bh
IuWFNg̃^Cv#TA_OBJECT_JOINT̏ꍇɂ̂ݗLȃo[֐łB
*/
//@{

	///WCg̉e͈̗͂LԂ̎擾
	/**
	\return e͈̗͂L
	*/
	BOOL GetJointAreaEnabled()const;

	///WCg̉e͈̗͂LԂ̃Zbg
	/**
	\param bEnabled e͈̗͂L
	*/
	void SetJointAreaEnabled(BOOL bEnabled);

	///WCg̐eWCg̃XP[̕␳Ԃ̎擾
	/**
	\return eWCg̃XP[̕␳
	*/
	BOOL GetJointParentScaleCompensated()const;

	///WCg̐eWCg̃XP[̕␳Ԃ̃Zbg
	/**
	\param bCompensated eWCg̃XP[̕␳
	*/
	void SetJointParentScaleCompensated(BOOL bCompensated);

//@}

/**
\anchor CameraMethod
\name Jp\bh
IuWFNg̃^Cv#TA_OBJECT_CAMERȀꍇɂ̂ݗLȃo[֐łB
*/
//@{

	///J̎ˉe^Cv̎擾
	/**
	\return ˉe^Cv
	*/
	TA_PROJECTION_TYPE GetCameraProjectionType()const;

	///J̎ˉe^CṽZbg
	/**
	\param ProjectionType ˉe^Cv
	*/
	void SetCameraProjectionType(TA_PROJECTION_TYPE ProjectionType);

	///JYp̎擾
	/**
	ˉe^Cv#TA_PROJECTION_PERSPECTIVȄꍇɎgp܂B
	\return Yp()
	*/
	float GetCameraViewAngle()const;

	///JYp̃Zbg
	/**
	ˉe^Cv#TA_PROJECTION_PERSPECTIVȄꍇɎgp܂B
	\param ViewAngle Yp()
	*/
	void SetCameraViewAngle(float ViewAngle);

	///J̎썂̎擾
	/**
	ˉe^Cv#TA_PROJECTION_ORTHȌꍇɎgp܂B
	\return ̍
	*/
	float GetCameraViewHeight()const;

	///J̎썂̃Zbg
	/**
	ˉe^Cv#TA_PROJECTION_ORTHȌꍇɎgp܂B
	\param ViewHeight ̍
	*/
	void SetCameraViewHeight(float ViewHeight);

//@}

/**
\anchor LightMethod
\name Cgp\bh
IuWFNg̃^Cv#TA_OBJECT_LIGHT̏ꍇɂ̂ݗLȃo[֐łB
*/
//@{

	///Cg̃ANeBuԂ̎擾
	/**
	\return ANeBu
	*/
	BOOL GetLightActive()const;

	///Cg̃ANeBuԂ̃Zbg
	/**
	\param bActive ANeBu
	*/
	void SetLightActive(BOOL bActive);

	///Cg J[̎擾
	/**
	\return RGBe0`1̒l
	*/
	TA_VECTOR GetLightColor()const;

	///Cg J[̃Zbg
	/**
	\param Color RGBe0`1̒l
	*/
	void SetLightColor(const TA_VECTOR& Color);

	///Cg̊gU̎擾
	/**
	\return 0`1̒l
	*/
	float GetLightDiffuse()const;

	///Cg̊gŨZbg
	/**
	\param Diffuse 0`1̒l
	*/
	void SetLightDiffuse(float Diffuse);

	///Cg̊̎擾
	/**
	\return 0`1̒l
	*/
	float GetLightAmbient()const;

	///Cg̊̃Zbg
	/**
	\param Ambient 0`1̒l
	*/
	void SetLightAmbient(float Ambient);

	///Cg̔ˌ̎擾
	/**
	\return 0`1̒l
	*/
	float GetLightSpecular()const;

	///Cg̔ˌ̃Zbg
	/**
	\param Specular 0`1̒l
	*/
	void SetLightSpecular(float Specular);

	///Cg ^Cv̎擾
	/**
	\return Cg ^Cv
	*/
	TA_LIGHT_TYPE GetLightType()const;

	///Cg ^CṽZbg
	/**
	\param LightType Cg ^Cv
	*/
	void SetLightType(TA_LIGHT_TYPE LightType);

	///Cǧ^Cv̎擾
	/**
	Cg ^Cv#TA_LIGHT_DIRECTIONALȊȌꍇɎgp܂B
	\return ^Cv
	*/
	TA_DECAY_TYPE GetLightDecayType()const;

	///Cǧ^CṽZbg
	/**
	Cg ^Cv#TA_LIGHT_DIRECTIONALȊȌꍇɎgp܂B
	\param DecayType ^Cv
	*/
	void SetLightDecayType(TA_DECAY_TYPE DecayType);

	///Cg̋x̎擾
	/**
	̒l}CiX̏ꍇA͈͂ÂȂ܂B
	\return Cg̋x
	*/
	float GetLightIntensity()const;

	///Cg̋x̃Zbg
	/**
	̒l}CiX̏ꍇA͈͂ÂȂ܂B
	\param Intensity Cg̋x
	*/
	void SetLightIntensity(float Intensity);

	///Cg̗L̎擾
	/**
	Cg ^Cv#TA_LIGHT_DIRECTIONALȊȌꍇɎgp܂B
	Cgƒ_̋̒l𒴂ƏƖɂȂ܂B
	\return Cg̗L
	*/
	float GetLightRange()const;

	///Cg̗L̃Zbg
	/**
	Cg ^Cv#TA_LIGHT_DIRECTIONALȊȌꍇɎgp܂B
	Cgƒ_̋̒l𒴂ƏƖɂȂ܂B
	\param Range Cg̗L
	*/
	void SetLightRange(float Range);

	///Cg̉~px̎擾
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	\return ~px(0`180)
	*/
	float GetLightConeAngle()const;

	///Cg̉~px̃Zbg
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	\param ConeAngle ~px(0`180)
	*/
	void SetLightConeAngle(float ConeAngle);

	///Cg̎px̎擾
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	X|bgCg̖邳͈͂̊pxłBvX̏ꍇ͉~px̊OA
	}CiX̏ꍇ͓ɂȂ܂B
	\return px(0`180)
	*/
	float GetLightPenumbraAngle()const;

	///Cg̎px̃Zbg
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	X|bgCg̖邳͈͂̊pxłBvX̏ꍇ͉~px̊OA
	}CiX̏ꍇ͓ɂȂ܂B
	\param PenumbraAngle px(0`180)
	*/
	void SetLightPenumbraAngle(float PenumbraAngle);

	///Cg̎̎擾
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	X|bg Cg̎ɂ閾邳̌łB1̏ꍇ͖邳ŜŃjAɌ܂B
	1傫ꍇ͎̊Ot߂ŋA1菬ꍇ͎̓t߂ŋ܂B
	\return 
	*/
	float GetLightFalloff()const;

	///Cg̎̃Zbg
	/**
	Cg ^Cv#TA_LIGHT_SPOT̏ꍇɎgp܂B
	X|bg Cg̎ɂ閾邳̌łB1̏ꍇ͖邳ŜŃjAɌ܂B
	1傫ꍇ͎̊Ot߂ŋA1菬ꍇ͎̓t߂ŋ܂B
	\param Falloff 
	*/
	void SetLightFalloff(float Falloff);

//@}

/**
\anchor ModelMethod
\name fp\bh
IuWFNg̃^Cv#TA_OBJECT_MODEL̏ꍇɂ̂ݗLȃo[֐łB
*/
//@{

	///}eA̎擾
	/**
	\return }eA
	*/
	UINT GetModelMaterialCount()const;

	///e}eÃCfbNX̍XV
	/**
	CTaMaterial::GetIndex() Ŏ擾}eÃCfbNXXV܂B
	*/
	void UpdateModelMaterialIndices();

	///}eAXg̎擾
	/**
	\param pMaterials }eÃXg
	\return ̏ꍇTRUEB
	*/
	BOOL GetModelMaterials(CTaMaterial* pMaterials[])const;

	///CfbNX̃}eA̎擾
	/**
	\param nIndex CfbNX
	\return }eA
	*/
	CTaMaterial* GetModelMaterial(UINT nIndex)const;

	///}eÃCfbNX̎擾
	/**
	\param pMaterial }eA
	\return CfbNX
	*/
	UINT GetModelMaterialIndex(const CTaMaterial* pMaterial)const;

	///Jg }eA̎擾
	/**
	\return }eA
	*/
	CTaMaterial* GetModelCurMaterial()const;

	///Jg }eÃZbg
	/**
	\param pMaterial }eA
	*/
	void SetModelCurMaterial(CTaMaterial* pMaterial);

	///}eA̒ǉ
	/**
	\param pMaterial }eA
	*/
	void AddModelMaterial(CTaMaterial* pMaterial);

	///}eAwCfbNXʒuɑ}
	/**
	\param nIndex CfbNX
	\param pMaterial }eA
	\return ̏ꍇTRUEB
	*/
	BOOL InsertModelMaterial(UINT nIndex, CTaMaterial* pMaterial);

	///}eA폜
	/**
	\param pMaterial }eA
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteModelMaterial(CTaMaterial* pMaterial);

	///SẴ}eA폜
	/**
	\return ̏ꍇTRUE
	*/
	BOOL DeleteAllModelMaterials();

	///Aj[V̎擾
	/**
	\return Aj[V
	*/
	UINT GetModelAnimCount()const;

	///eAj[ṼCfbNX̍XV
	/**
	CTaAnim::GetIndex() Ŏ擾Aj[ṼCfbNXXV܂B
	*/
	void UpdateModelAnimIndices();

	///Aj[VXg̎擾
	/**
	\param pAnims Aj[VXg
	\return ̏ꍇTRUEB
	*/
	BOOL GetModelAnims(CTaAnim* pAnims[])const;

	///CfbNX̃Aj[V̎擾
	/**
	\param nIndex CfbNX
	\return Aj[V
	*/
	CTaAnim* GetModelAnim(UINT nIndex)const;

	///Aj[ṼCfbNX擾
	/**
	\param pAnim Aj[V
	*/
	UINT GetModelAnimIndex(const CTaAnim* pAnim)const;

	///Jg Aj[V̎擾
	/**
	\return Aj[V
	*/
	CTaAnim* GetModelCurAnim()const;

	///Jg Aj[VZbg
	/**
	\param pAnim Aj[V
	*/
	void SetModelCurAnim(CTaAnim* pAnim);

	///Aj[V̒ǉ
	/**
	\param pAnim Aj[V
	*/
	void AddModelAnim(CTaAnim* pAnim);

	///CfbNXʒuɃAj[V}
	/**
	\param nIndex CfbNX
	\param pAnim Aj[V
	\return ̏ꍇTRUEB
	*/
	BOOL InsertModelAnim(UINT nIndex, CTaAnim* pAnim);

//@}

};
