#include "stdafx.h"
#include "Export.h"

//STL̕Aϒzgp
#if _MSC_VER <= 1200
	#pragma warning (disable:4786)
#endif
#include <string>
#include <vector>
using namespace std;

//Cfgp̕
#define IND ' '

//o̓t[Ԋu
#define FRAME_STEP 1.0f

//}eȀo
/*
strFile		t@Co͗pB
strIndent	CfgpB
pMaterial	o͂}eAB
*/
void WriteMaterial(string& strFile, string& strIndent, CTaMaterial* pMaterial)
{
	//Ɨpϐ
	char sz[256];
	TA_VECTOR vec;

	//Jn^O̒ǉ
	strFile += string("\r\n") + strIndent + "Material {";

	//Cfg𑝂₷
	strIndent += IND;

	//Ȍo
	strFile += string("\r\n") + strIndent + "Name " + pMaterial->GetName();

	//J[̏o
	vec = pMaterial->GetColor();
	sprintf(sz, "Color %.03f,%.03f,%.03f", vec.r, vec.g, vec.b);
	strFile += string("\r\n") + strIndent + sz;

	//gȔo
	sprintf(sz, "Diffuse %.03f", pMaterial->GetDiffuse());
	strFile += string("\r\n") + strIndent + sz;

	//̏o
	sprintf(sz, "Ambient %.03f", pMaterial->GetAmbient());
	strFile += string("\r\n") + strIndent + sz;

	//Ȕ̏o
	sprintf(sz, "Emissive %.03f", pMaterial->GetEmissive());
	strFile += string("\r\n") + strIndent + sz;

	//sx̏o
	sprintf(sz, "Alpha %.03f", pMaterial->GetAlpha());
	strFile += string("\r\n") + strIndent + sz;

	//ˌ̏o
	sprintf(sz, "Specular %.03f", pMaterial->GetSpecular());
	strFile += string("\r\n") + strIndent + sz;

	//˂̋̏o
	sprintf(sz, "Power %.03f", pMaterial->GetPower());
	strFile += string("\r\n") + strIndent + sz;

	//eNX`̎擾
	UINT nTextures = pMaterial->GetTextureCount();
	if(nTextures)
	{
		//Jn^O̒ǉ
		strFile += string("\r\n") + strIndent + "Textures {";

		//Cfg𑝂₷
		strIndent += IND;

		//eNX`̃[v
		for(UINT i = 0 ; i < nTextures; ++i)
		{
			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "Texture {";

			//Cfg𑝂₷
			strIndent += IND;

			//eNX` f[^̎擾
			LPCTSTR pszFilePath;
			TA_COLOR_OP_TYPE ColorOp;
			TA_ALPHA_OP_TYPE AlphaOp;
			pMaterial->GetTexture(i, &pszFilePath, &ColorOp, &AlphaOp);

			//t@C pX̏o
			sprintf(sz, "FilePath %s", pszFilePath);
			strFile += string("\r\n") + strIndent + sz;

			//Iy[V̏o
			sprintf(sz, "Op %d,%d", ColorOp, AlphaOp);
			strFile += string("\r\n") + strIndent + sz;

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";
		}

		//Cfg炷
		strIndent.erase(strIndent.size()-1);

		//I^O̒ǉ
		strFile += string("\r\n") + strIndent + "}";
	}

	//Cfg炷
	strIndent.erase(strIndent.size()-1);

	//I^O̒ǉ
	strFile += string("\r\n") + strIndent + "}";
}

//Aj[V ACȅo
/*
strFile		t@Co͗pB
strIndent	CfgpB
pAnimItem	o͂Aj[V ACeB
Type		o͂Aj[V ACẽ^CvB
*/
void WriteAnimItem(string& strFile, string& strIndent, CTaAnimItem* pAnimItem, TA_ANIM_ITEM_TYPE Type)
{
	//Ɨpϐ
	char sz[256];

	//Jn^O̒ǉ
	strFile += string("\r\n") + strIndent + "Item {";

	//Cfg𑝂₷
	strIndent += IND;

	//^Cv
	string strType;
	switch(Type)
	{
	case TA_ANIM_ITEM_SCALE_X:
		strType = "ScaleX";
		break;
	case TA_ANIM_ITEM_SCALE_Y:
		strType = "ScaleY";
		break;
	case TA_ANIM_ITEM_SCALE_Z:
		strType = "ScaleZ";
		break;
	case TA_ANIM_ITEM_ROTATE_X:
		strType = "RotateX";
		break;
	case TA_ANIM_ITEM_ROTATE_Y:
		strType = "RotateY";
		break;
	case TA_ANIM_ITEM_ROTATE_Z:
		strType = "RotateZ";
		break;
	case TA_ANIM_ITEM_TRANSLATE_X:
		strType = "TranslateX";
		break;
	case TA_ANIM_ITEM_TRANSLATE_Y:
		strType = "TranslateY";
		break;
	case TA_ANIM_ITEM_TRANSLATE_Z:
		strType = "TranslateZ";
		break;
	case TA_ANIM_ITEM_PIVOT_X:
		strType = "PivotX";
		break;
	case TA_ANIM_ITEM_PIVOT_Y:
		strType = "PivotY";
		break;
	case TA_ANIM_ITEM_PIVOT_Z:
		strType = "PivotZ";
		break;
	default:
		break;
	}

	//^Cvo
	strFile += string("\r\n") + strIndent + "Type " + strType;

	//L[ t[o
	UINT nCount = pAnimItem->GetKeyFrameCount();
	sprintf(sz, "KeyFrame %d", nCount);
	strFile += string("\r\n") + strIndent + sz;

	//L[ t[ [v
	for(UINT i = 0; i < nCount; ++i)
	{
		//l̎擾
		float Frame, Value;
		pAnimItem->GetKeyFrame(i, &Frame, &Value);

		//L[ t[o
		sprintf(sz, " %.03f,%.03f", Frame, Value);
		strFile += sz;
	}

	//Cfg炷
	strIndent.erase(strIndent.size()-1);

	//I^O̒ǉ
	strFile += string("\r\n") + strIndent + "}";
}

//Aj[V̏o
/*
strFile				t@Co͗pB
strIndent			CfgpB
pAnim				o͂Aj[VB
Objects				SIuWFNg̃XgB
bMatrix				TRUȄꍇAAj[VIuWFNg̕ϊsŏóB
bApplyConstraint	TRUȄꍇAIKȂǂ̍SIuWFNg̎pɔfďóB
*/
void WriteAnim(string& strFile, string& strIndent, CTaAnim* pAnim, const vector<CTaObject*>& Objects, BOOL bMatrix, BOOL bApplyConstraint)
{
	//Ɨpϐ
	char sz[256];

	//Jn^O̒ǉ
	strFile += string("\r\n") + strIndent + "Anim {";

	//Cfg𑝂₷
	strIndent += IND;

	//Oo
	strFile += string("\r\n") + strIndent + "Name " + pAnim->GetName();

	//t[ [go
	sprintf(sz, "Fps %.03f", pAnim->GetFps());
	strFile += string("\r\n") + strIndent + sz;

	//݂̃t[o
	sprintf(sz, "CurFrame %.03f", pAnim->GetCurFrame());
	strFile += string("\r\n") + strIndent + sz;

	//ŏ̃t[o
	sprintf(sz, "FirstFrame %.03f", pAnim->GetFirstFrame());
	strFile += string("\r\n") + strIndent + sz;

	//Ō̃t[o
	sprintf(sz, "LastFrame %.03f", pAnim->GetLastFrame());
	strFile += string("\r\n") + strIndent + sz;

	//so͂ꍇAo͗p̈Ԋũt[̃XgZo
	vector<float> Frames;
	if(bMatrix)
	{
		//t[
		UINT nFrames = (UINT)((pAnim->GetLastFrame()-pAnim->GetFirstFrame())/FRAME_STEP + 1.0f);

		//t[o
		sprintf(sz, "Frames %d ", nFrames);
		strFile += string("\r\n") + strIndent + sz;

		//t[̃[v
		Frames.resize(nFrames);
		for(UINT n = 0; n < nFrames; ++n)
		{
			//t[̎Zo
			float Frame = pAnim->GetFirstFrame()+FRAME_STEP*n;

			//t[o
			if(n == 0)
				sprintf(sz, "%.03f", (double)Frame);
			else
				sprintf(sz, ",%.03f", (double)Frame);
			strFile +=  sz;

			//t[ XgɃZbg
			Frames[n] = pAnim->GetFirstFrame()+FRAME_STEP*n;
		}
	}

	//o͂Aj[V
	CTaAnim* pOutAnim = NULL;

	//pAj[V
	CTaAnim* pDupAnim = TaCreateAnim();

	//IKnh̃Aj[V݂A
	//QƃIuWFNg̃Aj[Vɕϊꍇ
	if(bApplyConstraint && pAnim->GetConstrainedObjectItems(pDupAnim, FRAME_STEP, TRUE))
		pOutAnim = pDupAnim;
	else
		pOutAnim = pAnim;

	//IuWFNg [v
	for(UINT i = 0; i < Objects.size(); ++i)
	{
		//IuWFNg̎擾
		CTaObject* pObject = Objects[i];

		//̃IuWFNgɂẴACe݂Ȃꍇ
		if(pOutAnim->IsObjectItemEmpty(pObject))
			continue;

		//Jn^O̒ǉ
		strFile += string("\r\n") + strIndent + "Object {";

		//Cfg𑝂₷
		strIndent += IND;

		//IuWFNg̊Kw̎擾
		string strTreeName;
		strTreeName.resize(pObject->GetTreeNameLength());
		pObject->GetTreeName(&strTreeName[0]);

		//Kw̏o
		sprintf(sz, "TreeName %s", strTreeName.c_str());
		strFile += string("\r\n") + strIndent + sz;

		//ԊũIuWFNg̕ϊso͂ꍇ
		if(bMatrix)
		{
			//x̒ǉ
			strFile += string("\r\n") + strIndent + "Matrices";

			//Aj[VsɂĕύXIuWFNg̃p[^ێ
			CTaAnimValues* pAnimValues = TaCreateAnimValues();
			pAnimValues->StoreObjectValues(pOutAnim, pObject);

			//t[̃[v
			UINT nFrames = Frames.size();
			for(UINT n = 0; n < Frames.size(); ++n)
			{
				//wt[ŃIuWFNg̃Aj[Vs
				pOutAnim->AnimateObjectItems(pObject, Frames[n]);

				//IuWFNg̕ϊs̎擾
				TA_MATRIX Matrix;
				pObject->GetTransform(Matrix);

				//s̏o
				for(UINT i = 0; i < 4; i++)
				{
					if(i == 0)
						sprintf(sz, " %.03f,%.03f,%.03f,%.03f", (double)Matrix.m[i][0], (double)Matrix.m[i][1], (double)Matrix.m[i][2], (double)Matrix.m[i][3]);
					else
						sprintf(sz, ",%.03f,%.03f,%.03f,%.03f", (double)Matrix.m[i][0], (double)Matrix.m[i][1], (double)Matrix.m[i][2], (double)Matrix.m[i][3]);

					strFile += sz;
				}
			}

			//IuWFNg̃p[^𕜌
			pAnimValues->Restore(pOutAnim);
			TaDeleteAnimValues(pAnimValues);
		}
		//Aj[V ACeo͂ꍇ
		else
		{
			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "Items {";

			//Cfg𑝂₷
			strIndent += IND;

			//Aj[V ACẽ^Cv
			TA_ANIM_ITEM_TYPE Type;

			//Aj[V ACe
			CTaAnimItem* pItem;

			//ړXɂ
			Type = TA_ANIM_ITEM_TRANSLATE_X;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//ړYɂ
			Type = TA_ANIM_ITEM_TRANSLATE_Y;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//ړZɂ
			Type = TA_ANIM_ITEM_TRANSLATE_Z;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//]Xɂ
			Type = TA_ANIM_ITEM_ROTATE_X;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//]Yɂ
			Type = TA_ANIM_ITEM_ROTATE_Y;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//]Zɂ
			Type = TA_ANIM_ITEM_ROTATE_Z;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//XP[Xɂ
			Type = TA_ANIM_ITEM_SCALE_X;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//XP[Yɂ
			Type = TA_ANIM_ITEM_SCALE_Y;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);
			//XP[Zɂ
			Type = TA_ANIM_ITEM_SCALE_Z;
			if((pItem = pAnim->GetObjectItem(Type, pObject)) != NULL)
				WriteAnimItem(strFile, strIndent, pItem, Type);

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";
		}

		//Cfg炷
		strIndent.erase(strIndent.size()-1);

		//I^O̒ǉ
		strFile += string("\r\n") + strIndent + "}";
	}

	//Aj[V̕폜
	TaDeleteAnim(pDupAnim);

	//Cfg炷
	strIndent.erase(strIndent.size()-1);

	//I^O̒ǉ
	strFile += string("\r\n") + strIndent + "}";
}

//IuWFNg̏o
/*
strFile:			t@Co͗pB
strIndent:			CfgpB
pObject:			o͂IuWFNgB
Objects:			IuWFNg̃XgB
bMatrix:			TRUȄꍇAAj[VIuWFNg̕ϊsŏóB
bApplyConstraint:	TRUȄꍇAIKȂǂ̍SIuWFNg̎pɔfďóB
*/
void WriteObject(string& strFile, string& strIndent, CTaObject* pObject, vector<CTaObject*>& Objects, BOOL bMatrix, BOOL bApplyConstraint)
{
	//IuWFNg̃Xgɒǉ
	Objects.push_back(pObject);

	//Ɨpϐ
	char sz[256];
	TA_VECTOR vec;

	//Jn^O̒ǉ
	strFile += string("\r\n") + strIndent + "Object {";

	//Cfg𑝂₷
	strIndent += IND;

	//^Cv̏o
	strFile += string("\r\n") + strIndent + "Type " + pObject->GetTypeName();

	//Ȍo
	strFile += string("\r\n") + strIndent + "Name " + pObject->GetName();

	//IC[p̏̏o
	sprintf(sz, "EulerOrder %d", pObject->GetEulerOrder());
	strFile += string("\r\n") + strIndent + sz;

	//ړ̏o
	vec = pObject->GetTranslate();
	sprintf(sz, "Translate %.3f,%.3f,%.3f", vec.x, vec.y, vec.z);
	strFile += string("\r\n") + strIndent + sz;

	//](IC[p)̏o
	vec = pObject->GetAngle();
	sprintf(sz, "Rotate %.3f,%.3f,%.3f", vec.x, vec.y, vec.z);
	strFile += string("\r\n") + strIndent + sz;

	//XP[̏o
	vec = pObject->GetScale();
	sprintf(sz, "Scale %.3f,%.3f,%.3f", vec.x, vec.y, vec.z);
	strFile += string("\r\n") + strIndent + sz;

	//f̏o
	vec = pObject->GetShear();
	sprintf(sz, "Shear %.3f,%.3f,%.3f", vec.x, vec.y, vec.z);
	strFile += string("\r\n") + strIndent + sz;

	//f̏ꍇ
	if(pObject->GetType() == TA_OBJECT_MODEL)
	{
		//}eA̎擾
		UINT nMaterials = pObject->GetModelMaterialCount();
		if(nMaterials)
		{
			//X̃}eÃCfbNXXVĂ
			pObject->UpdateModelMaterialIndices();

			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "Materials {";

			//Cfg𑝂₷
			strIndent += IND;

			//}eA f[^̏o
			for(UINT i = 0 ; i < nMaterials; ++i)
				WriteMaterial(strFile, strIndent, pObject->GetModelMaterial(i));

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";

			//݂̃}eA擾
			CTaMaterial* pCurMaterial = pObject->GetModelCurMaterial();
			if(pCurMaterial)
			{
				//}eÃCfbNXo
				sprintf(sz, "CurMaterial %d", pCurMaterial->GetIndex());
				strFile += string("\r\n") + strIndent + sz;
			}
		}
	}
	//WbVWCg̏ꍇ
	else if(pObject->GetType() == TA_OBJECT_MESH || pObject->GetType() == TA_OBJECT_JOINT)
	{
		//_̎擾
		UINT nVertices = pObject->GetVertexCount();
		if(nVertices)
		{
			//_̏o
			sprintf(sz, "Vertices %d", nVertices);
			strFile += string("\r\n") + strIndent + sz;

			//_ʒuf[^̎擾
			vector<TA_VECTOR> Positions(nVertices);
			pObject->GetVertexPositions(&Positions.front());

			//_[v
			for(UINT i = 0; i < nVertices; ++i)
			{
				//_Wlo
				TA_VECTOR& pos = Positions[i];
				sprintf(sz, " %.03f,%.03f,%.03f", pos.x, pos.y, pos.z);	
				strFile += sz;
			}

			//_̃{[ f[^݂ꍇ
			if(pObject->HasVertexBone())
			{
				//f[^擾pz
				vector<BYTE*>  Indices(nVertices);
				vector<float*> Weights(nVertices);
				for(i = 0; i < nVertices; ++i)
				{
					Indices[i] = new BYTE[TA_MAX_VERTEX_BONE_COUNT];
					Weights[i] = new float[TA_MAX_VERTEX_BONE_COUNT];
				}

				//_̃{[ CfbNXƃEFCg擾
				pObject->GetVertexBones(&Indices.front(), &Weights.front());

				//_̃{[ CfbNXo
				sprintf(sz, "VertexBones %d", nVertices);
				strFile += string("\r\n") + strIndent + sz;
				for(i = 0; i < nVertices; ++i)
				{
					sprintf(sz, " %d,%d,%d,%d", Indices[i][0], Indices[i][1], Indices[i][2], Indices[i][3]);	
					strFile += sz;
				}
	
				//_̃EFCgo
				sprintf(sz, "VertexWeights %d", nVertices);
				strFile += string("\r\n") + strIndent + sz;
				for(i = 0; i < nVertices; ++i)
				{
					sprintf(sz, " %.03f,%.03f,%.03f,%.03f", Weights[i][0], Weights[i][1], Weights[i][2], Weights[i][3]);	
					strFile += sz;
				}

				//f[^擾pz̍폜
				for(i = 0; i < nVertices; ++i)
				{
					delete[] Indices[i];
					delete[] Weights[i];
				}
 			}
		}

		//ʐ̎擾
		UINT nFaces = pObject->GetFaceCount();
		if(nFaces)
		{
			//ʐ̏o
			sprintf(sz, "Faces %d", nFaces);
			strFile += string("\r\n") + strIndent + sz;

			//ʂ̒_擾
			vector<UINT> Counts(nFaces);
			pObject->GetFaceVertexCounts(&Counts.front());

			//ʂ̒_CfbNX擾
			vector<int*> Indices(nFaces);
			for(UINT i = 0; i < nFaces; ++i)
				Indices[i] = (Counts[i] != 0) ? new int[Counts[i]] : NULL;
			pObject->GetFaceVertexIndices(&Indices.front());

			//ʃ[v
			for(i = 0; i < nFaces; ++i)
			{
				//ʂ̒_
				sprintf(sz, " %d", Counts[i]);
				strFile += sz;

				//ʂ̒_[v
				for(UINT j = 0; j < Counts[i]; ++j)
				{
					//_̃CfbNXo
					sprintf(sz, ",%d", Indices[i][j]);
					strFile += sz;
				}
			}

			//f[^擾pz̍폜
			for(i = 0; i < nFaces; ++i)
				if(Indices[i])
					delete[] Indices[i];
		}

		//ʂ݂ꍇ
		if(nFaces)
		{
			//ʐ̏o
			sprintf(sz, "FaceMaterials %d", nFaces);
			strFile += string("\r\n") + strIndent + sz;

			//ʂ̎Qƃ}eA擾
			vector<CTaMaterial*> Materials(nFaces);
			pObject->GetFaceMaterials(&Materials.front());

			//ʃ[v
			for(UINT i = 0; i < nFaces; ++i)
			{
				//Qƃ}eÃCfbNXo
				sprintf(sz, " %d", Materials[i] != NULL ? Materials[i]->GetIndex() : -1);
				strFile += sz;
			}
		}

		//ʂ݂ꍇ
		if(nFaces)
		{
			//ʐ̏o
			sprintf(sz, "FlatShades %d", nFaces);
			strFile += string("\r\n") + strIndent + sz;

			//ʂ̒_擾
			vector<UINT> Counts(nFaces);
			pObject->GetFaceVertexCounts(&Counts.front());

			//ʂ̒_̃tbg VF[fBO tO擾
			vector<BOOL*> FlatShades(nFaces);
			for(UINT i = 0; i < nFaces; ++i)
				FlatShades[i] = Counts[i] != 0 ? new BOOL[Counts[i]] : NULL;
			pObject->GetFaceVertexFlatShades(&FlatShades.front());

			//ʃ[v
			for(i = 0; i < nFaces; ++i)
			{
				//ʂ̒_o
				sprintf(sz, " %d", Counts[i]);
				strFile += sz;

				//ʂ̒_[v
				for(UINT j = 0; j < Counts[i]; ++j)
				{
					//_̃tbg VF[fBO tOo
					sprintf(sz, ",%d", FlatShades[i][j]);
					strFile += sz;
				}
			}

			//f[^擾pz̍폜
			for(i = 0; i < nFaces; ++i)
				if(FlatShades[i])
					delete[] FlatShades[i];
		}

		//ʂ݂ꍇ
		if(nFaces)
		{
			//ʐ̏o
			sprintf(sz, "UVs %d", nFaces);
			strFile += string("\r\n") + strIndent + sz;

			//ʂ̒_擾
			vector<UINT> Counts(nFaces);
			pObject->GetFaceVertexCounts(&Counts.front());

			//ʂ̒_UV擾
			vector<TA_VECTOR_2D*> UVs(nFaces);
			for(UINT i = 0; i < nFaces; ++i)
				UVs[i] = Counts[i] != 0 ? new TA_VECTOR_2D[Counts[i]] : NULL;
			pObject->GetFaceVertexUVs(&UVs.front());

			//ʃ[v
			for(i = 0; i < nFaces; ++i)
			{
				//ʂ̒_o
				sprintf(sz, " %d", Counts[i]);
				strFile += sz;

				//ʂ̒_[v
				for(UINT j = 0; j < Counts[i]; ++j)
				{
					//_UVo
					sprintf(sz, ",%.03f,%.03f", UVs[i][j].x, UVs[i][j].y);
					strFile += sz;
				}
			}

			//f[^擾pz̍폜
			for(i = 0; i < nFaces; ++i)
				if(UVs[i])
					delete[] UVs[i];
		}

		//{[̎擾
		UINT nBones = pObject->GetBoneCount();
		if(nBones)
		{
			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "Bones {";

			//Cfg𑝂₷
			strIndent += IND;

			//{[ Xg̎擾
			vector<CTaObject*> Bones(nBones);
			pObject->GetBones(&Bones.front());

			//{[̃[v
			for(UINT i = 0; i < nBones; ++i)
			{
				//Jn^O̒ǉ
				strFile += string("\r\n") + strIndent + "Object {";

				//Cfg𑝂₷
				strIndent += IND;

				//IuWFNg̎擾
				CTaObject* pBone = Bones[i];

				//Kw̎擾
				string strTreeName;
				strTreeName.resize(pBone->GetTreeNameLength());
				pBone->GetTreeName(&strTreeName[0]);

				//Kw̏o
				sprintf(sz, "TreeName %s", strTreeName.c_str());
				strFile += string("\r\n") + strIndent + sz;

				//Cfg炷
				strIndent.erase(strIndent.size()-1);

				//I^O̒ǉ
				strFile += string("\r\n") + strIndent + "}";
			}

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";

			//XL̃oChϊs擾
			TA_MATRIX SkinMat;
			pObject->GetSkinBindTransform(SkinMat);

			//s̊evfo
			strFile += string("\r\n") + strIndent + "SkinBindTransform";
			for(i = 0; i < 4; ++i)
			{
				if(i == 0)
					sprintf(sz, " %.03f,%.03f,%.03f,%.03f", SkinMat.m[i][0], SkinMat.m[i][1], SkinMat.m[i][2], SkinMat.m[i][3]);
				else
					sprintf(sz, ",%.03f,%.03f,%.03f,%.03f", SkinMat.m[i][0], SkinMat.m[i][1], SkinMat.m[i][2], SkinMat.m[i][3]);

				strFile += sz;
			}

			//e{[̃oChϊs擾
			vector<TA_MATRIX> BoneBindMatrices(nBones);
			pObject->GetBoneBindTransforms(&BoneBindMatrices.front());

			//x̒ǉ
			sprintf(sz, "BoneBindTransforms %d", nBones);
			strFile += string("\r\n") + strIndent + sz;

			//s̃[v
			for(UINT j = 0; j < nBones; ++j)
			{
				//s̊evfo
				TA_MATRIX& mat = BoneBindMatrices[j];
				for(i = 0; i < 4; ++i)
				{
					if(i == 0)
						sprintf(sz, " %.03f,%.03f,%.03f,%.03f", mat.m[i][0], mat.m[i][1], mat.m[i][2], mat.m[i][3]);
					else
						sprintf(sz, ",%.03f,%.03f,%.03f,%.03f", mat.m[i][0], mat.m[i][1], mat.m[i][2], mat.m[i][3]);

					strFile += sz;
				}
			}

			//oCh|[ỸIuWFNg擾
			UINT nObjects = pObject->GetBindPoseObjectCount();

			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "BindPose {";

			//Cfg𑝂₷
			strIndent += IND;

			//oCh |[Ỹf[^擾
			vector<CTaObject*> BindObjects(nObjects);
			vector<TA_VECTOR> Translates(nObjects);
			vector<TA_VECTOR> Rotates(nObjects);
			vector<TA_VECTOR> Scales(nObjects);
			vector<TA_VECTOR> Shears(nObjects);
			pObject->GetBindPose(&BindObjects.front(), &Translates.front(), &Rotates.front(), &Scales.front(), &Shears.front());

			//oCh |[Ỹ[v
			for(i = 0; i < nObjects; ++i)
			{
				//Jn^O̒ǉ
				strFile += string("\r\n") + strIndent + "Object {";

				//Cfg𑝂₷
				strIndent += IND;

				//IuWFNg̎擾
				CTaObject* pBindObject = BindObjects[i];

				//Kw̎擾
				string strTreeName;
				strTreeName.resize(pBindObject->GetTreeNameLength());
				pBindObject->GetTreeName(&strTreeName[0]);

				//Kw̏o
				sprintf(sz, "TreeName %s", strTreeName.c_str());
				strFile += string("\r\n") + strIndent + sz;

				//ep[^̏o
				strFile += string("\r\n") + strIndent + "Params";
				sprintf(sz, " %.03f,%.03f,%.03f", Translates[i].x, Translates[i].y, Translates[i].z);
				strFile += sz;
				sprintf(sz, " %.03f,%.03f,%.03f", Rotates[i].x, Rotates[i].y, Rotates[i].z);
				strFile += sz;
				sprintf(sz, " %.03f,%.03f,%.03f", Scales[i].x, Scales[i].y, Scales[i].z);
				strFile += sz;
				sprintf(sz, " %.03f,%.03f,%.03f", Shears[i].x, Shears[i].y, Shears[i].z);
				strFile += sz;

				//Cfg炷
				strIndent.erase(strIndent.size()-1);

				//I^O̒ǉ
				strFile += string("\r\n") + strIndent + "}";
			}

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";
		}
	}
	//WCg̏ꍇ(o[W1.6.1.3Œǉ)
	else if(pObject->GetType() == TA_OBJECT_JOINT)
	{
		//e͈̗͂LԂ̏o
		sprintf(sz, "JointAreaEnabled %d", pObject->GetJointAreaEnabled());
		strFile += string("\r\n") + strIndent + sz;
	}
	//J̏ꍇ(o[W1.6.1.3Œǉ)
	else if(pObject->GetType() == TA_OBJECT_CAMERA)
	{
		//ˉe^Cv̏o
		sprintf(sz, "CameraProjectionType %d", pObject->GetCameraProjectionType());
		strFile += string("\r\n") + strIndent + sz;

		//Yp̏o
		sprintf(sz, "CameraViewAngle %.3f", pObject->GetCameraViewAngle());
		strFile += string("\r\n") + strIndent + sz;

		//썂̏o
		sprintf(sz, "CameraViewHeight %.3f", pObject->GetCameraViewHeight());
		strFile += string("\r\n") + strIndent + sz;
	}
	//Cg̏ꍇ(o[W1.6.1.3Œǉ)
	else if(pObject->GetType() == TA_OBJECT_LIGHT)
	{
		//J[̏o
		vec = pObject->GetLightColor();
		sprintf(sz, "LightColor %.03f,%.03f,%.03f", vec.r, vec.g, vec.b);
		strFile += string("\r\n") + strIndent + sz;

		//gȔo
		sprintf(sz, "LightDiffuse %.03f", pObject->GetLightDiffuse());
		strFile += string("\r\n") + strIndent + sz;

		//̏o
		sprintf(sz, "LightAmbient %.03f", pObject->GetLightAmbient());
		strFile += string("\r\n") + strIndent + sz;

		//ˌ̏o
		sprintf(sz, "LightSpecular %.03f", pObject->GetLightSpecular());
		strFile += string("\r\n") + strIndent + sz;

		//Cg ^Cv̏o
		sprintf(sz, "LightType %d", pObject->GetLightType());
		strFile += string("\r\n") + strIndent + sz;

		//x̏o
		sprintf(sz, "LightIntensity %.03f", pObject->GetLightIntensity());
		strFile += string("\r\n") + strIndent + sz;

		//~px̏o
		sprintf(sz, "LightConeAngle %.03f", pObject->GetLightConeAngle());
		strFile += string("\r\n") + strIndent + sz;

		//ӕpx̏o
		sprintf(sz, "LightPenumbraAngle %.03f", pObject->GetLightPenumbraAngle());
		strFile += string("\r\n") + strIndent + sz;
	}

	//qIuWFNgɂčċAĂяo
	for(UINT i = 0; i < pObject->GetChildCount(); ++i)
		WriteObject(strFile, strIndent, pObject->GetChild(i), Objects, bMatrix, bApplyConstraint);

	//f̏ꍇ
	if(pObject->GetType() == TA_OBJECT_MODEL)
	{
		//Aj[V̎擾
		UINT nAnims = pObject->GetModelAnimCount();
		if(nAnims)
		{
			//Jn^O̒ǉ
			strFile += string("\r\n") + strIndent + "Anims {";

			//Cfg𑝂₷
			strIndent += IND;

			//Aj[V f[^̏o
			for(i = 0 ; i < nAnims; ++i)
				WriteAnim(strFile, strIndent, pObject->GetModelAnim(i), Objects, bMatrix, bApplyConstraint);

			//Cfg炷
			strIndent.erase(strIndent.size()-1);

			//I^O̒ǉ
			strFile += string("\r\n") + strIndent + "}";
		}

		//݂̃Aj[V擾
		CTaAnim* pCurAnim = pObject->GetModelCurAnim();
		if(pCurAnim)
		{
			//CfbNX̏o
			sprintf(sz, "CurAnim %d", pObject->GetModelAnimIndex(pCurAnim));
			strFile += string("\r\n") + strIndent + sz;
		}
	}

	//Cfg炷
	strIndent.erase(strIndent.size()-1);

	//I^O̒ǉ
	strFile += string("\r\n") + strIndent + "}";
}

//eLXgt@C̏o
/*
pszFilePath			t@C̃tpXB
pScene				V[B
bMatrix				TRUȄꍇAAj[VIuWFNg̕ϊsŏóB
bApplyConstraint	TRUȄꍇAIKȂǂ̍SIuWFNg̎pɔfďóB
*/
BOOL WriteTextFile(LPCTSTR pszFilePath, CTaScene* pScene, BOOL bMatrix, BOOL bApplyConstraint)
{
	//t@C̍쐬ɎsƂ
	HANDLE hFile = ::CreateFile(pszFilePath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, 0);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;

	//f[^o͗p
	string strFile;

	//̂߁AGA\
	strFile.reserve(1000000);

	//Cfgp
	string strIndent;

	//Jn^O̒ǉ
	strFile += string("\r\n") + "Scene {";

	//Cfg𑝂₷
	strIndent += IND;

	//IuWFNg̃Xg
	vector<CTaObject*> Objects;

	//IuWFNg̃f[^o
	WriteObject(strFile, strIndent, pScene->GetRootModel(), Objects, bMatrix, bApplyConstraint);

	//Cfg炷
	strIndent.erase(strIndent.size()-1);

	//I^O̒ǉ
	strFile += string("\r\n") + "}";

	//t@Cɏ
	DWORD dwBytes;
	::WriteFile(hFile, strFile.c_str(), strFile.size(), &dwBytes, 0);

	//t@C
	::CloseHandle(hFile);

	return TRUE;
}
