#pragma once

#include "TaAnimItem.h"

/**
\file TaAnim.h
\brief Aj[V NX`Ă܂B
*/

class CTaObject;

/**
\ingroup ClassGroup
\brief Aj[V NX
*/
class CTaAnim
{
	///RXgN^(gps)
	/**
	RXgN^gpĂ͂܂B
	CX^X̍쐬ɂ TaCreateAnim() 𗘗pĂB
	*/
	CTaAnim(){}

	///fXgN^(gps)
	/**
	fXgN^gpĂ͂܂B
	CX^X̍폜ɂ TaDeleteAnim() 𗘗pĂB
	*/
	~CTaAnim(){}

public:

	///O̎擾
	/**
	\return 
	*/
	LPCTSTR GetName()const;

	///ÕZbg
	/**
	\param pszName 
	*/
	void SetName(LPCTSTR pszName);

	///CfbNX̎擾
	/**
	\return CTaObject::UpdateModelAnimIndices() ōXVꂽCfbNX
	*/
	UINT GetIndex()const;

	///CfbNX̃Zbg
	/**
	\param nIndex CfbNX
	*/
	void SetIndex(UINT nIndex);

	///t[ [g̎擾
	/**
	\return t[ [g(Frame/b)
	*/
	float GetFps()const;

	///t[[g̃Zbg
	/**
	\param Fps t[ [g(Frame/b)
	*/
	BOOL SetFps(float Fps);

	///Jg t[擾
	/**
	\return t[ԍ
	*/
	float GetCurFrame()const;

	///Jg t[Zbg
	/**
	\param Frame t[ԍ
	*/
	void SetCurFrame(float Frame);

	///ŏ̃t[擾
	/**
	\return t[ԍ
	*/
	float GetFirstFrame()const;

	///ŏ̃t[Zbg
	/**
	\param Frame t[ԍ
	*/
	BOOL SetFirstFrame(float Frame);

	///Ō̃t[擾
	/**
	\return t[ԍ
	*/
	float GetLastFrame()const;

	///Ō̃t[Zbg
	/**
	\param Frame t[ԍ
	*/
	BOOL SetLastFrame(float Frame);

	///IuWFNg̃Aj[V ACe󂩂ǂ
	/**
	\param pObject IuWFNg
	\return ̏ꍇTRUEB
	*/
	BOOL IsObjectItemEmpty(CTaObject* pObject)const;

	///IuWFNg̃Aj[V ACe̎擾
	/**
	\param Type Aj[V ACẽ^Cv
	\param pObject IuWFNg
	\return Aj[V ACe
	*/
	CTaAnimItem* GetObjectItem(TA_ANIM_ITEM_TYPE Type, CTaObject* pObject)const;

	///IuWFNg̃Aj[V ACẽAj[Vs
	/**
	\param Type Aj[V ACẽ^Cv
	\param pObject IuWFNg
	\param Frame t[ԍ
	\return sꂽꍇTRUEB
	*/
	BOOL AnimateObjectItem(TA_ANIM_ITEM_TYPE Type, CTaObject* pObject, float Frame)const;

	///IuWFNg̑SẴAj[V ACẽAj[Vs
	/**
	\param pObject IuWFNg
	\param Frame t[ԍ
	\return sꂽꍇTRUEB
	*/
	BOOL AnimateObjectItems(CTaObject* pObject, float Frame)const;

	///IuWFNg̃Aj[V ACe̍쐬
	/**
	w^CvAIuWFNg̃ACe݂ꍇÃACeԂ܂B
	\param Type Aj[V ACẽ^Cv
	\param pObject IuWFNg
	\return Aj[V ACe
	*/
	CTaAnimItem* CreateObjectItem(TA_ANIM_ITEM_TYPE Type, CTaObject* pObject);

	///IuWFNg̃Aj[V ACe̍폜
	/**
	\param Type Aj[V ACẽ^Cv
	\param pObject IuWFNg
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteObjectItem(TA_ANIM_ITEM_TYPE Type, CTaObject* pObject);

	///IuWFNg̃Aj[V ACe̍폜
	/**
	wIuWFNgQƂSẴACe폜܂B
	\param pObject IuWFNg
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteObjectItems(CTaObject* pObject);

	///SẴIuWFNg̃Aj[V ACe̍폜
	/**
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteObjectItems();

	///IuWFNg̃Aj[V ACẽN[Abv
	/**
	ʏ͂̊֐ĂяoKv͂܂B
	*/
	void CleanUpObjectItems();

	///SẴAj[V ACe̍폜
	void ClearItems();

	///IKnhȂǂ̍S(RXgCg)pIuWFNg̃Aj[V𕡐
	/**
	IKnhȂǂ̍S(RXgCg)pIuWFNgAj[VĂꍇA
	SQƃIuWFNgɔfꂽԂ̃Aj[V܂B
	ŜȂꍇ͕͍sꂸFALSEԂ܂B
	\param pAnim ZbgAj[V
	\param FrameStep L[ t[̎
	\param bAttachIKHandle IKnhA^b`邩ǂB
	\return ꂽꍇTRUEB
	*/
	BOOL GetConstrainedObjectItems(CTaAnim* pAnim, float FrameStep, BOOL bAttachIKHandle)const;
};
