#pragma once

#include "TaLibSymbol.h"

/**
\file TaAnimItem.h
\brief Aj[V ACe NX`Ă܂B
*/

/**
\ingroup ClassGroup
\brief Aj[V ACe NX
*/
class CTaAnimItem
{
	///RXgN^(gps)
	/**
	RXgN^gpĂ͂܂B
	CX^X̍쐬ɂ CTaAnim::CreateObjectItem() 𗘗pĂB
	*/
	CTaAnimItem(){}

	///fXgN^(gps)
	/**
	fXgN^gpĂ͂܂B
	CX^X̍폜ɂ CTaAnim::DeleteObjectItem() 𗘗pĂB
	*/
	~CTaAnimItem(){}

public:

	///Aj[Vs
	/**
	\param Frame t[ԍ
	\return sꂽꍇTRUEB
	*/
	BOOL Animate(float Frame)const;

	///L[ t[̎擾
	/**
	\return L[ t[
	*/
	UINT GetKeyFrameCount()const;

	///wCfbNX̃L[ t[̃f[^擾
	/**
	\param nIndex CfbNX
	\param pFrame t[ԍ
	\param pValue Aj[V̒l
	\param pLeftTanType L[̑ǑX̃^Cv
	\param pRightTanType L[̌㑤̌X̃^Cv
	\param pLeftTan L[̑ǑX
	\param pRightTan L[̌㑤̌X
	\param pTanSeparated XꍇATRUEB
	\return ̏ꍇTRUEB
	*/
	BOOL GetKeyFrame(UINT nIndex, float* pFrame, float* pValue = NULL, TA_TAN_TYPE* pLeftTanType = NULL, TA_TAN_TYPE* pRightTanType = NULL,
		float* pLeftTan = NULL, float* pRightTan = NULL, BOOL* pTanSeparated = NULL)const;

	///wCfbNX̃L[ t[̃f[^Zbg
	/**
	\param nIndex CfbNX
	\param pValue Aj[V̒l
	\param pLeftTanType L[̑ǑX̃^Cv
	\param pRightTanType L[̌㑤̌X̃^Cv
	\param pLeftTan L[̑ǑX
	\param pRightTan L[̌㑤̌X
	\param pTanSeparated XꍇATRUEB
	\param bUpdateSpline TRUȄꍇAXvCȐXV܂B
	\return ̏ꍇTRUEB
	*/
	BOOL SetKeyFrame(UINT nIndex, const float* pValue, const TA_TAN_TYPE* pLeftTanType = NULL, const TA_TAN_TYPE* pRightTanType = NULL,
							   const float* pLeftTan = NULL, const float* pRightTan = NULL, const BOOL* pTanSeparated = NULL, BOOL bUpdateSpline = FALSE);

	///L[ t[쐬
	/**
	łɎwt[ԍɃL[ t[ꍇAf[^㏑܂B
	\param Frame t[ԍ
	\param Value Aj[V̒l
	\param pLeftTanType L[̑ǑX̃^Cv
	\param pRightTanType L[̌㑤̌X̃^Cv
	\param pLeftTan L[̑ǑX
	\param pRightTan L[̌㑤̌X
	\param pTanSeparated XꍇATRUEB
	\param bUpdateSpline TRUȄꍇAXvCȐXV܂B
	*/
	void InsertKeyFrame(float Frame, float Value, const TA_TAN_TYPE* pLeftTanType = NULL, const TA_TAN_TYPE* pRightTanType = NULL, 
									const float* pLeftTan = NULL, const float* pRightTan = NULL, const BOOL* pTanSeparated = NULL, BOOL bUpdateSpline = FALSE);

	///wCfbNX̃L[ t[폜
	/**
	\param nIndex CfbNX
	\param bUpdateSpline TRUȄꍇAXvCȐXV܂B
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteKeyFrame(UINT nIndex, BOOL bUpdateSpline = FALSE);

	///SẴL[t[폜
	void DeleteKeyFrames();

	///XvCȐ̍XV
	void UpdateSpline();
};

