#pragma once

/**
\file TaLibSymbol.h
\brief }N񋓌^A\̂̐錾Ă܂
*/

/**
\addtogroup SymbolGroup
*/
//@{

///vOC֐DLLGNX|[gp}N
#ifndef TA_PLUGIN_EXPORT
	#define TA_PLUGIN_EXPORT extern "C" __declspec(dllexport)
#endif

///ToyStudio SDK̃o[W(1.6.1.3)̏ʂ̒l
#ifndef TA_SDK_VERSION_MS
	#define TA_SDK_VERSION_MS 0x00010006
#endif

///ToyStudio SDK̃o[W(1.6.1.3)̉ʂ̒l
#ifndef TA_SDK_VERSION_LS
	#define TA_SDK_VERSION_LS 0x00010003
#endif

///~
#define TA_PI 3.141592653f

///x烉WAɕϊ
#define TA_TO_RADIAN(degree) ((degree)*(TA_PI/180.0f))

///WAxɕϊ
#define TA_TO_DEGREE(radian) ((radian)*(180.0f/TA_PI))

///1_̍ő{[
#define TA_MAX_VERTEX_BONE_COUNT 4

///J[(A,R,G,B̏)
typedef DWORD TA_COLOR;

///A,R,G,B̊e1oCgTA_COLOR֕ϊ
#define TA_ARGB(a,r,g,b) ((TA_COLOR)((((a)&0xff)<<24)|(((r)&0xff)<<16)|(((g)&0xff)<<8)|((b)&0xff)))

///#TA_COLORAl擾
#define TA_GET_A(rgb) ((BYTE)((rgb)>>24))

///#TA_COLORRl擾
#define TA_GET_R(rgb) ((BYTE)((rgb)>>16))

///#TA_COLORGl擾
#define TA_GET_G(rgb) ((BYTE)((rgb)>>8))

///#TA_COLORBl擾
#define TA_GET_B(rgb) ((BYTE)(rgb))

///vOCvf̃^Cv
enum TA_PLUGIN_ELEMENT_TYPE
{
	TA_PLUGIN_ELEMENT_IMPORT	= 0x00000001, ///< C|[g
	TA_PLUGIN_ELEMENT_EXPORT	= 0x00000002, ///< GNX|[g
};

///J[ Iy[V ^Cv
enum TA_COLOR_OP_TYPE
{
	TA_COLOR_OP_DISABLE,				///< 
	TA_COLOR_OP_CURRENT,				///< Jg J[݂̂g
	TA_COLOR_OP_TEXTURE,				///< eNX` J[݂̂g
	TA_COLOR_OP_MODULATE,				///< |킹
	TA_COLOR_OP_MODULATE2X,				///< |킹2{
	TA_COLOR_OP_MODULATE4X,				///< |킹4{
	TA_COLOR_OP_ADD,					///< Z
	TA_COLOR_OP_SUBTRACT_CURRENT,		///< eNX` J[Jg J[
	TA_COLOR_OP_SUBTRACT_TEXTURE,		///< Jg J[eNX` J[
	TA_COLOR_OP_CURRENT_ALPHA_CURRENT,	///< Jg̃At@lɃJg J[uh
	TA_COLOR_OP_CURRENT_ALPHA_TEXTURE,	///< Jg̃At@lɃeNX` J[uh
	TA_COLOR_OP_TEXTURE_ALPHA_CURRENT,	///< eNX`̃At@lɃJg J[uh
	TA_COLOR_OP_TEXTURE_ALPHA_TEXTURE,	///< eNX`̃At@lɂɃeNX`J[uh
	TA_COLOR_OP_BUMP,					///< ov}bv
	TA_COLOR_OP_BUMP_LUMINANCE,			///< Pxtov}bv
};

///At@ Iy[V ^Cv
enum TA_ALPHA_OP_TYPE
{
	TA_ALPHA_OP_DISABLE,			///< 
	TA_ALPHA_OP_CURRENT,			///< Jg̃At@l݂̂g
	TA_ALPHA_OP_TEXTURE,			///< eNX`̃At@l݂̂g
	TA_ALPHA_OP_MODULATE,			///< |킹
	TA_ALPHA_OP_MODULATE2X,			///< |킹2{
	TA_ALPHA_OP_MODULATE4X,			///< |킹4{
	TA_ALPHA_OP_ADD,				///< Z
	TA_ALPHA_OP_SUBTRACT_CURRENT,	///< eNX` At@lJg At@l
	TA_ALPHA_OP_SUBTRACT_TEXTURE,	///< Jg At@leNX` At@l
};

///IuWFNg̃^Cv
enum TA_OBJECT_TYPE
{
	TA_OBJECT_NONE,			///< ȃ^Cv
	TA_OBJECT_MESH,			///< bV
	TA_OBJECT_GROUP,		///< O[v
	TA_OBJECT_MODEL,		///< f
	TA_OBJECT_NULL,			///< k
	TA_OBJECT_JOINT,		///< WCg
	TA_OBJECT_CAMERA,		///< J
	TA_OBJECT_IK_HANDLE,	///< IKnh
	TA_OBJECT_LIGHT			///< Cg(o[W1.6.1.3ǉ)
};

///IC[p̉]
enum TA_EULER_ORDER_TYPE
{
	TA_EULER_ORDER_XYZ,	///< XYZ
	TA_EULER_ORDER_XZY,	///< XZY
	TA_EULER_ORDER_YXZ,	///< YXZ
	TA_EULER_ORDER_YZX,	///< YZX
	TA_EULER_ORDER_ZXY,	///< ZXY
	TA_EULER_ORDER_ZYX	///< ZYX
};

///ˉe^Cv(o[W1.6.1.3ǉ)
enum TA_PROJECTION_TYPE
{
	TA_PROJECTION_PERSPECTIVE, ///< p[XyNeBuˉe
	TA_PROJECTION_ORTHO        ///< ˉe
};

///Cg ^Cv(o[W1.6.1.3ǉ)
enum TA_LIGHT_TYPE
{
	TA_LIGHT_DIRECTIONAL,	///< sCg
	TA_LIGHT_POINT,			///< |Cg Cg
	TA_LIGHT_SPOT			///< X|bg Cg
};

///^Cv(o[W1.6.1.3ǉ)
enum TA_DECAY_TYPE
{
	TA_DECAY_NONE,		///< Ȃ
	TA_DECAY_LINEAR,	///< ɔ
	TA_DECAY_QUADRATIC	///< 2ɔ
};

///Aj[V ACẽ^Cv
enum TA_ANIM_ITEM_TYPE
{
	TA_ANIM_ITEM_NONE,			///< ȃ^Cv
	TA_ANIM_ITEM_SCALE_X,		///< XP[X
	TA_ANIM_ITEM_SCALE_Y,		///< XP[Y
	TA_ANIM_ITEM_SCALE_Z,		///< XP[Z
	TA_ANIM_ITEM_ROTATE_X,		///< ]X(P)
	TA_ANIM_ITEM_ROTATE_Y,		///< ]Y(P)
	TA_ANIM_ITEM_ROTATE_Z,		///< ]Z(P)
	TA_ANIM_ITEM_TRANSLATE_X,	///< ړX
	TA_ANIM_ITEM_TRANSLATE_Y,	///< ړY
	TA_ANIM_ITEM_TRANSLATE_Z,	///< ړZ
	TA_ANIM_ITEM_PIVOT_X,		///< s{bgX
	TA_ANIM_ITEM_PIVOT_Y,		///< s{bgY
	TA_ANIM_ITEM_PIVOT_Z,		///< s{bgZ
	TA_ANIM_ITEM_SHEAR_X,		///< fX(o[W1.6.0.7ǉ)
	TA_ANIM_ITEM_SHEAR_Y,		///< fY(o[W1.6.0.7ǉ)
	TA_ANIM_ITEM_SHEAR_Z,		///< fZ(o[W1.6.0.7ǉ)
	TA_ANIM_ITEM_VISIBLE		///< (o[W1.6.0.7ǉ)
};

///Aj[V ACěX̃^Cv
enum TA_TAN_TYPE
{
	TA_TAN_SPLINE,		///< XvC
	TA_TAN_LINEAR,		///< jA
	TA_TAN_SPECIFIED,	///< Xw
	TA_TAN_STEP,		///< Ki
	TA_TAN_STEP_NEXT	///< KiŎ̃L[̒l
};

//@}

/**
\addtogroup StructGroup
*/
//@{ 

///3DxNg
struct TA_VECTOR
{
	TA_VECTOR()
	{
	}

	TA_VECTOR(float x, float y, float z)
		: x(x)
		, y(y)
		, z(z)
	{
	}

	TA_VECTOR(const float* pVal)
		: x(pVal[0])
		, y(pVal[1])
		, z(pVal[2])
	{
	}

	~TA_VECTOR()
	{
	}

	operator const float*()const{return m;}
	operator float*(){return m;}

	union
	{
		float m[3];
		struct
		{
			float x, y, z;
		};
		struct
		{
			float r, g, b;
		};
	};
};

///2DxNg
struct TA_VECTOR_2D
{
	TA_VECTOR_2D()
	{
	}

	TA_VECTOR_2D(float x, float y)
		: x(x)
		, y(y)
	{
	}

	TA_VECTOR_2D(const float* pVal)
		: x(pVal[0])
		, y(pVal[1])
	{
	}

	~TA_VECTOR_2D()
	{
	}

	operator const float*()const{return m;}
	operator float*(){return m;}

	union
	{
		float m[2];
		struct
		{
			float x, y;
		};
		struct
		{
			float u, v;
		};
	};
};

///NH[^jI(4DxNg)
struct TA_QUAT
{
	TA_QUAT()
	{
	}

	TA_QUAT(float x, float y, float z, float w)
		: x(x)
		, y(y)
		, z(z)
		, w(w)
	{
	}

	TA_QUAT(const float* pVal)
		: x(pVal[0])
		, y(pVal[1])
		, z(pVal[2])
		, w(pVal[3])
	{
	}

	~TA_QUAT()
	{
	}

	operator const float*()const{return m;}
	operator float*(){return m;}

	union
	{
		float m[4];
		struct
		{
			float x, y, z, w;
		};
		struct
		{
			float r, g, b, a;
		};
	};
};

///4~4s
struct TA_MATRIX
{
	TA_MATRIX()
	{
	}

	TA_MATRIX(
		float _11, float _12, float _13, float _14,
		float _21, float _22, float _23, float _24,
		float _31, float _32, float _33, float _34,
		float _41, float _42, float _43, float _44)
	 : _11(_11), _12(_12), _13(_13), _14(_14)
	 , _21(_21), _22(_22), _23(_23), _24(_24)
	 , _31(_31), _32(_32), _33(_33), _34(_34)
	 , _41(_41), _42(_42), _43(_43), _44(_44)
	{
	}

	TA_MATRIX(const float* pVal)
	 : _11(pVal[0]), _12(pVal[1]), _13(pVal[2]), _14(pVal[3])
	 , _21(pVal[4]), _22(pVal[5]), _23(pVal[6]), _24(pVal[7])
	 , _31(pVal[8]), _32(pVal[9]), _33(pVal[10]), _34(pVal[11])
	 , _41(pVal[12]), _42(pVal[13]), _43(pVal[14]), _44(pVal[15])
	{
	}

	~TA_MATRIX()
	{
	}

	operator const float*()const{return m[0];}
	operator float*(){return m[0];}

	union
	{
		float m[4][4];
		struct
		{
			float _11, _12, _13, _14;
			float _21, _22, _23, _24;
			float _31, _32, _33, _34;
			float _41, _42, _43, _44;
		};
	};
};

//@}
