#pragma once

#include "TaLibSymbol.h"

/**
\file TaMaterial.h
\brief }eA NX`Ă܂B
*/

class CTaScene;

/**
\ingroup ClassGroup
\brief }eA NX
*/
class CTaMaterial
{
	///RXgN^(gps)
	/**
	RXgN^gpĂ͂܂B
	CX^X̍쐬ɂ TaCreateMaterial() 𗘗pĂB
	*/
	CTaMaterial(){}

	///fXgN^(gps)
	/**
	fXgN^gpĂ͂܂B
	CX^X̍폜ɂ TaDeleteMaterial() 𗘗pĂB
	*/
	~CTaMaterial(){}

public:

	///O̎擾
	/**
	\return 
	*/
	LPCTSTR GetName()const;

	///ÕZbg
	/**
	\param pszName 
	*/
	void SetName(LPCTSTR pszName);

	///CfbNX̎擾
	/**
	\return CTaObject::UpdateModelMaterialIndices() ōXVꂽCfbNX
	*/
	UINT GetIndex()const;

	///CfbNX̃Zbg
	/**
	\param nIndex CfbNX
	*/
	void SetIndex(UINT nIndex);

	///J[̎擾
	/**
	\return RGBe0`1̒l
	*/
	TA_VECTOR GetColor()const;

	///J[̃Zbg
	/**
	\param Color RGBe0`1̒l
	*/
	void SetColor(const TA_VECTOR& Color);

	///gU̎擾
	/**
	\return 0`1̒l
	*/
	float GetDiffuse()const;

	///gŨZbg
	/**
	\param Diffuse 0`1̒l
	*/
	void SetDiffuse(float Diffuse);

	///̎擾
	/**
	\return 0`1̒l
	*/
	float GetAmbient()const;

	///̃Zbg
	/**
	\param Ambient 0`1̒l
	*/
	void SetAmbient(float Ambient);

	///Ȕ̎擾
	/**
	\return 0`1̒l
	*/
	float GetEmissive()const;

	///Ȕ̃Zbg
	/**
	\param Emissive 0`1̒l
	*/
	void SetEmissive(float Emissive);

	///sx̎擾
	/**
	\return 0`1̒l
	*/
	float GetAlpha()const;

	///sx̃Zbg
	/**
	\param Alpha 0`1̒l
	*/
	void SetAlpha(float Alpha);

	///ˌ̎擾
	/**
	\return 0`1̒l
	*/
	float GetSpecular()const;

	///ˌ̃Zbg
	/**
	\param Specular 0`1̒l
	*/
	void SetSpecular(float Specular);

	///˂̋̎擾
	/**
	\return 0`̒l
	*/
	float GetPower()const;

	///˂̋̃Zbg
	/**
	\param Power 0`̒l
	*/
	void SetPower(float Power);

	///eNX`擾
	/**
	\return eNX`
	*/
	UINT GetTextureCount()const;

	///CfbNXʒũeNX`擾
	/**
	\param nIndex CfbNX
	\param ppszFilePath eNX`̃t@CpX
	\param pColorOp eNX`̃J[ Iy[V ^Cv
	\param pAlphaOp eNX`̃At@ Iy[V ^Cv
	\return ̏ꍇTRUEB
	*/
	BOOL GetTexture(UINT nIndex, LPCTSTR* ppszFilePath, TA_COLOR_OP_TYPE* pColorOp, TA_ALPHA_OP_TYPE* pAlphaOp)const;

	///eNX`̒ǉ
	/**
	\param pszFilePath eNX`̃t@CpX
	\param ColorOp eNX`̃J[ Iy[V ^Cv
	\param AlphaOp eNX`̃At@ Iy[V ^Cv
	\param pScene NULL̏ꢃ}C hLg̃AvptH_̂݁ANULLłȂꍇ̓f t@C̃tH_[B
	\return t@C̓ǂݍ݂ɐꍇTRUEBǂݍ݂ɎsꍇłAXgɂ͒ǉ܂B
	*/
	BOOL AddTexture(LPCTSTR pszFilePath, TA_COLOR_OP_TYPE ColorOp, TA_ALPHA_OP_TYPE AlphaOp, CTaScene* pScene = NULL);

	///CfbNXʒuɃeNX`}
	/** 
	\param nIndex CfbNX
	\param pszFilePath eNX`̃t@CpX
	\param ColorOp eNX`̃J[ Iy[V ^Cv
	\param AlphaOp eNX`̃At@ Iy[V ^Cv
	\param pScene NULL̏ꢃ}C hLg̃AvptH_̂݁ANULLłȂꍇ̓f t@C̃tH_[B
	\return t@C̓ǂݍ݂ɐꍇTRUEBǂݍ݂ɎsꍇłAXgɂ͒ǉ܂B
	*/
	BOOL InsertTexture(UINT nIndex, LPCTSTR pszFilePath, TA_COLOR_OP_TYPE ColorOp, TA_ALPHA_OP_TYPE AlphaOp, CTaScene* pScene = NULL);

	///CfbNXʒũeNX`[h
	/**
	\param nIndex CfbNX
	\param pScene NULL̏ꢃ}C hLg̃AvptH_̂݁ANULLłȂꍇ̓f t@C̃tH_[B
	\return ̏ꍇTRUEB
	*/
	BOOL ReloadTexture(UINT nIndex, CTaScene* pScene = NULL);

	///CfbNXʒũeNX`폜
	/**
	\param nIndex CfbNX
	\return ̏ꍇTRUEB
	*/
	BOOL DeleteTexture(UINT nIndex);

	///eNX`Sč폜
	void DeleteAllTextures();
};
