#include "stdafx.h"
#include "Import.h"

//STL̕Aϒzgp
#if _MSC_VER <= 1200
	#pragma warning (disable:4786)
#endif
#include <string>
#include <vector>
using namespace std;

//̃g[N擾}N
#define GET_NEXT_TOKEN_DLM(str, start, end, delimit) \
	((start = str.find_first_not_of(delimit, end)) != -1 && \
	(end = str.find_first_of(delimit, start)) != -1) 

//̃g[N擾}N
#define GET_NEXT_TOKEN_DLM2(str, start, end, delimit1, delimit2) \
	((start = str.find_first_not_of(delimit1, end)) != -1 && \
	(end = str.find_first_of(delimit2, start)) != -1) 

//̃g[N擾}N
#define GET_NEXT_TOKEN(str, start, end) GET_NEXT_TOKEN_DLM(str, start, end, " \t\r\n{")

//̖O擾}N
#define GET_NEXT_NAME(str, start, end) \
	GET_NEXT_TOKEN_DLM2(str, start, end, " \t\r\n", "\r\n")

//g[Nr}N
#define COMPARE_TOKEN(str, start, end, name) (str.compare(start, end-start, name) == 0) 

//̃g[N `FbN }N
#define CHECK_NEXT_TOKEN(str, start, end, name) \
	(GET_NEXT_TOKEN(str, start, end) && COMPARE_TOKEN(str, start, end, name))

//{[p\
struct BONE_INFO
{
	BONE_INFO()
		: pSkin(NULL)
	{
	}
	~BONE_INFO()
	{
	}

	//XL
	CTaObject* pSkin;

	//XL̃oChϊs
	TA_MATRIX SkinBindTransform;

	//{[̖OXg
	vector<string> BoneNames;

	//{[̃oChϊs񃊃Xg
	vector<TA_MATRIX> BoneBindTransforms;

	//oCh |[ỸIuWFNgXg
	vector<string> BindPoseObjectNames;

	//oCh |[ŸړXg
	vector<TA_VECTOR> BindPoseTranslates;

	//oCh |[Ỷ]Xg
	vector<TA_VECTOR> BindPoseAngles;

	//oCh |[ỸXP[
	vector<TA_VECTOR> BindPoseScales;

	//oCh |[ŶfXg
	vector<TA_VECTOR> BindPoseShears;
};

//Aj[V ACe̓ǂݍ
/*
strFile		t@C͗pB
nStartPos	g[ÑX^[gʒuB
nEndPos		g[ÑGhʒuB
pAnimItem	ǂݍݐAj[V ACe
*/
void ReadAnimItem(const string& strFile, size_t& nStartPos, size_t& nEndPos, CTaAnimItem* pAnimItem)
{
	//Ɨpϐ
	string str;
	float key, val;

	//̃g[N̎擾
	while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
	{
		//L[ t[̏ꍇ
		if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "KeyFrame"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//L[ t[̎擾
			UINT nKeys = atoi(str.c_str());
			if(nKeys)
			{
				//L[ t[̃[v
				for(UINT i = 0; i < nKeys; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//L[ t[̒ǉ
					sscanf(str.c_str(), "%f,%f", &key, &val);
					pAnimItem->InsertKeyFrame(key, val);
				}
			}

			//XvCȐ̍XV
			pAnimItem->UpdateSpline();
		}
		//I^Ȍꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
			return;
	}
}

//}eA̓ǂݍ
/*
strFile		t@C͗pB
nStartPos	g[ÑX^[gʒuB
nEndPos		g[ÑGhʒuB
pScene		V[B
pMaterial	ǂݍݐ}eAB
*/
void ReadMaterial(const string& strFile, size_t& nStartPos, size_t& nEndPos, CTaScene* pScene, CTaMaterial* pMaterial)
{
	//Ɨpϐ
	string str;
	TA_VECTOR vec;

	//̃g[N̎擾
	while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
	{
		//Ȍꍇ
		if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Name"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ÕZbg
			pMaterial->SetName(str.c_str());
		}
		//J[̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Color"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//J[̃Zbg
			sscanf(str.c_str(), "%f,%f,%f", &vec.r, &vec.g, &vec.b);
			pMaterial->SetColor(vec);
		}
		//gȔꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Diffuse"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//gŨZbg
			pMaterial->SetDiffuse(atof(str.c_str()));
		}
		//̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Ambient"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//̃Zbg
			pMaterial->SetAmbient(atof(str.c_str()));
		}
		//Ȕ̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Emissive"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Ȕ̃Zbg
			pMaterial->SetEmissive(atof(str.c_str()));
		}
		//sx̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Alpha"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//sx̃Zbg
			pMaterial->SetAlpha(atof(str.c_str()));
		}
		//ˌ̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Specular"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ˌ̃Zbg
			pMaterial->SetSpecular(atof(str.c_str()));
		}
		//˂̋̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Power"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//˂̋̃Zbg
			pMaterial->SetPower(atof(str.c_str()));
		}
		//eNX` Xg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Textures"))
		{
			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//eNX`̏ꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Texture"))
				{
					//t@CpX
					string strFilePath;

					//̃g[N̎擾
					while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
					{
						//t@CpX̏ꍇ
						if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "FilePath"))
						{
							//̃g[N̎擾
							if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
								return;

							//t@CpX̎擾
							strFilePath = strFile.substr(nStartPos, nEndPos-nStartPos);
						}
						//Iy[V̏ꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Op"))
						{
							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//Iy[V̎擾
							UINT nColorOp, nAlphaOp;
							sscanf(str.c_str(), "%d,%d", &nColorOp, &nAlphaOp);

							//eNX`̒ǉ
							pMaterial->AddTexture(strFilePath.c_str(), (TA_COLOR_OP_TYPE)nColorOp, (TA_ALPHA_OP_TYPE)nAlphaOp, pScene);
						}
						//I^Ȍꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
							break;
					}
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//I^Ȍꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
			return;
	}
}

//Aj[V̓ǂݍ
/*
strFile		t@C͗pB
nStartPos	g[ÑX^[gʒuB
nEndPos		g[ÑGhʒuB
pRootModel	[g fB
pMaterial	ǂݍݐAj[VB
bMatrix		TRUȄꍇAAj[VIuWFNg̕ϊsœǂݍށB
*/
void ReadAnim(const string& strFile, size_t& nStartPos, size_t& nEndPos, CTaObject* pRootModel, CTaAnim* pAnim, BOOL bMatrix)
{
	//Ɨpϐ
	string str;
	TA_VECTOR vec;

	//Aj[VΏۂ̃IuWFNg
	CTaObject* pObject = NULL;

	//Aj[VԊu̕ϊsœǂݍޏꍇ̃t[ Xg
	vector<float> Frames;

	//̃g[N̎擾
	while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
	{
		//Ȍꍇ
		if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Name"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ÕZbg
			pAnim->SetName(str.c_str());
		}
		//t[ [g̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Fps"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//t[ [g̃Zbg
			pAnim->SetFps(atof(str.c_str()));
		}
		//݂̃t[̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CurFrame"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//݂̃t[̃Zbg
			pAnim->SetCurFrame(atof(str.c_str()));
		}
		//ŏ̃t[̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "FirstFrame"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ŏ̃t[̃Zbg
			pAnim->SetFirstFrame(atof(str.c_str()));
		}
		//Ō̃t[̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LastFrame"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Ō̃t[̃Zbg
			pAnim->SetLastFrame(atof(str.c_str()));
		}
		//Aj[VԊu̕ϊsœǂݍޏꍇŁAt[ Xg̏ꍇ
		else if(bMatrix && COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Frames"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//t[擾AXgTCY
			UINT nFrames = atoi(str.c_str());
			Frames.resize(nFrames);

			if(nFrames)
			{
				//t[̃[v
				for(UINT i = 0; i < nFrames; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//t[Zbg
					sscanf(str.c_str(), "%f", &Frames[i]);
				}
			}
		}
		//IuWFNg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Object"))
		{
			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//Kw̏ꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TreeName"))
				{
					//̃g[N̎擾
					if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//ΏۃIuWFNg̎擾
					pObject = pRootModel->FindTreeName(str.c_str());
				}
				//Aj[VԊu̕ϊsœǂݍޏꍇŁAϊs̏ꍇ
				else if(bMatrix && COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Matrices"))
				{
					//t[Lȏꍇ
					UINT nFrames = Frames.size();
					if(nFrames)
					{
						//IuWFNg̎pp[^ێ
						TA_VECTOR Translate	= pObject->GetTranslate();
						TA_VECTOR Angle		= pObject->GetAngle();
						TA_VECTOR Scale		= pObject->GetScale();
						TA_VECTOR Shear		= pObject->GetShear();

						//Aj[V ACe̍쐬
						CTaAnimItem* pTranslateX	= pAnim->CreateObjectItem(TA_ANIM_ITEM_TRANSLATE_X, pObject);
						CTaAnimItem* pTranslateY	= pAnim->CreateObjectItem(TA_ANIM_ITEM_TRANSLATE_Y, pObject);
						CTaAnimItem* pTranslateZ	= pAnim->CreateObjectItem(TA_ANIM_ITEM_TRANSLATE_Z, pObject);
						CTaAnimItem* pRotateX		= pAnim->CreateObjectItem(TA_ANIM_ITEM_ROTATE_X, pObject);
						CTaAnimItem* pRotateY		= pAnim->CreateObjectItem(TA_ANIM_ITEM_ROTATE_Y, pObject);
						CTaAnimItem* pRotateZ		= pAnim->CreateObjectItem(TA_ANIM_ITEM_ROTATE_Z, pObject);
						CTaAnimItem* pScaleX		= pAnim->CreateObjectItem(TA_ANIM_ITEM_SCALE_X, pObject);
						CTaAnimItem* pScaleY		= pAnim->CreateObjectItem(TA_ANIM_ITEM_SCALE_Y, pObject);
						CTaAnimItem* pScaleZ		= pAnim->CreateObjectItem(TA_ANIM_ITEM_SCALE_Z, pObject);

						//t[̃[v
						for(UINT i = 0; i < nFrames; ++i)
						{
							//t[擾
							float Frame = Frames[i];

							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//s̗vf̎擾
							TA_MATRIX mat;
							sscanf(str.c_str(), "%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f",
								&mat.m[0][0], &mat.m[0][1], &mat.m[0][2], &mat.m[0][3],
								&mat.m[1][0], &mat.m[1][1], &mat.m[1][2], &mat.m[1][3],
								&mat.m[2][0], &mat.m[2][1], &mat.m[2][2], &mat.m[2][3],
								&mat.m[3][0], &mat.m[3][1], &mat.m[3][2], &mat.m[3][3]);

							//ϊsɂăIuWFNg̎pp[^XV
							pObject->SetTransform(mat);

							//eAj[V ACeɃL[ t[ǉ
							//px̒Pʂ͓x()Ȃ̂ŒӁB
							vec = pObject->GetTranslate();
							pTranslateX->InsertKeyFrame(Frame, vec.x);
							pTranslateY->InsertKeyFrame(Frame, vec.y);
							pTranslateZ->InsertKeyFrame(Frame, vec.z);
							vec = pObject->GetAngle();
							pRotateX->InsertKeyFrame(Frame, TA_TO_DEGREE(vec.x));
							pRotateY->InsertKeyFrame(Frame, TA_TO_DEGREE(vec.y));
							pRotateZ->InsertKeyFrame(Frame, TA_TO_DEGREE(vec.z));
							vec = pObject->GetScale();
							pScaleX->InsertKeyFrame(Frame, vec.x);
							pScaleY->InsertKeyFrame(Frame, vec.y);
							pScaleZ->InsertKeyFrame(Frame, vec.z);
						}

						//eAj[V ACẽXvCȐ̍XV
						pTranslateX->UpdateSpline();
						pTranslateY->UpdateSpline();
						pTranslateZ->UpdateSpline();
						pRotateX->UpdateSpline();
						pRotateY->UpdateSpline();
						pRotateZ->UpdateSpline();
						pScaleX->UpdateSpline();
						pScaleY->UpdateSpline();
						pScaleZ->UpdateSpline();

						//IuWFNg̎pp[^𕜌
						pObject->SetScale(Scale);
						pObject->SetShear(Shear);
						pObject->SetAngle(Angle);
						pObject->SetTranslate(Translate);
					}
				}
				//Aj[VACeœǂݍޏꍇŁAACe Xg̏ꍇ
				else if(!bMatrix && COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Items"))
				{
					//̃g[N̎擾
					while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
					{
						//ACȅꍇ
						if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Item"))
						{
							//̃^O^CvȂꍇ
							if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Type"))
								return;

							//̃g[N擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//ACẽ^Cv擾
							TA_ANIM_ITEM_TYPE Type = TA_ANIM_ITEM_NONE;
							if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TranslateX"))
								Type = TA_ANIM_ITEM_TRANSLATE_X;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TranslateY"))
								Type = TA_ANIM_ITEM_TRANSLATE_Y;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TranslateZ"))
								Type = TA_ANIM_ITEM_TRANSLATE_Z;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "RotateX"))
								Type = TA_ANIM_ITEM_ROTATE_X;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "RotateY"))
								Type = TA_ANIM_ITEM_ROTATE_Y;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "RotateZ"))
								Type = TA_ANIM_ITEM_ROTATE_Z;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "ScaleX"))
								Type = TA_ANIM_ITEM_SCALE_X;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "ScaleY"))
								Type = TA_ANIM_ITEM_SCALE_Y;
							else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "ScaleZ"))
								Type = TA_ANIM_ITEM_SCALE_Z;

							//ACe̍쐬
							CTaAnimItem* pItem = pAnim->CreateObjectItem(Type, pObject);
							if(!pItem)
								return;

							//ACe̓ǂݍ
							ReadAnimItem(strFile, nStartPos, nEndPos, pItem);
						}
						//I^Ȍꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
							break;
					}
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//I^Ȍꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
			return;
	}
}

//IuWFNg̓ǂݍ
/*
strFile		t@C͗pB
nStartPos	g[ÑX^[gʒuB
nEndPos		g[ÑGhʒuB
pScene		V[B
pObject		ǂݍݐIuWFNgB
BoneRefs	{[񃊃XgB
bMatrix		TRUȄꍇAAj[VIuWFNg̕ϊsœǂݍށB
*/
void ReadObject(const string& strFile, size_t& nStartPos, size_t& nEndPos, CTaScene* pScene, CTaObject* pObject, vector<BONE_INFO*>& BoneInfos, BOOL bMatrix)
{
	//Ɨpϐ
	string str;
	TA_VECTOR vec;

	//{[
	BONE_INFO* pBoneInfo = NULL;

	//̃g[N̎擾
	while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
	{
		//Ȍꍇ
		if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Name"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ÕZbg
			pObject->SetName(str.c_str());
		}
		//IC[p̉]̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "EulerOrder"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//]̃Zbg
			pObject->SetEulerOrder(static_cast<TA_EULER_ORDER_TYPE>(atoi(str.c_str())));
		}
		//ړ̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Translate"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ړ̃Zbg
			sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
			pObject->SetTranslate(vec);
		}
		//](IC[p)̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Rotate"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//]̃Zbg
			//ɉ]ZbgĂKv̂ŒӁB
			sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
			pObject->SetAngle(vec);
		}
		//XP[̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Scale"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//XP[̃Zbg
			sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
			pObject->SetScale(vec);
		}
		//f̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Shear"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//f̃Zbg
			sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
			pObject->SetShear(vec);
		}
		//}eA Xg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Materials"))
		{
			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//}eȀꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Material"))
				{
					//}eA̍쐬
					CTaMaterial* pMaterial = TaCreateMaterial();
					pObject->AddModelMaterial(pMaterial);

					//}eA̓ǂݍ
					ReadMaterial(strFile, nStartPos, nEndPos, pScene, pMaterial);
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//݂̃}eȀꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CurMaterial"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//݂̃}eAZbg
			pObject->SetModelCurMaterial(pObject->GetModelMaterial(atoi(str.c_str())));
		}
		//IuWFNg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Object"))
		{
			//̃^O^CvȂꍇ
			if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Type"))
				return;

			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//IuWFNg ^Cv
			TA_OBJECT_TYPE Type = TA_OBJECT_NULL;

			//bV̏ꍇ
			if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Mesh"))
				Type = TA_OBJECT_MESH;
			//O[v̏ꍇ
			else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Group"))
				Type = TA_OBJECT_GROUP;
			//WCg̏ꍇ
			else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Joint"))
				Type = TA_OBJECT_JOINT;
			//J̏ꍇ(o[W1.6.1.3Œǉ)
			else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Camera"))
				Type = TA_OBJECT_CAMERA;
			//Cg̏ꍇ(o[W1.6.1.3Œǉ)
			else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Light"))
				Type = TA_OBJECT_LIGHT;
			//̑̏ꍇAkƂB
			else
				Type = TA_OBJECT_NULL;

			//IuWFNg̍쐬
			CTaObject* pChild = TaCreateObject(Type, pScene);
			if(!pChild)
				return;

			//qƂĒǉ
			pObject->AddChild(pChild);

			//qIuWFNgɂēǂݍ
			ReadObject(strFile, nStartPos, nEndPos, pScene, pChild, BoneInfos, bMatrix);
		}
		//_̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Vertices"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//_̎擾
			UINT nVertices = atoi(str.c_str());
			if(nVertices)
			{
				//_[v
				for(UINT i = 0; i < nVertices; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//_̒ǉ
					sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
					pObject->AddVertex(vec);
				}
			}
		}
		//_̃{[ CfbNX̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "VertexBones"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//_̎擾
			UINT nVertices = atoi(str.c_str());
			if(nVertices)
			{
				//f[^ Zbgpz
				vector<BYTE*> Indices(nVertices);
				for(UINT i = 0; i < nVertices; ++i)
					Indices[i] = new BYTE[TA_MAX_VERTEX_BONE_COUNT];

				//_[v
				for(i = 0; i < nVertices; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//{[ CfbNX̎擾
					int i0,i1,i2,i3;
					sscanf(str.c_str(), "%d,%d,%d,%d", &i0, &i1, &i2, &i3);
					Indices[i][0] = i0;
					Indices[i][1] = i1;
					Indices[i][2] = i2;
					Indices[i][3] = i3;
				}

				//_̃{[ CfbNXZbg
				pObject->SetVertexBones(&Indices.front(), NULL);

				//f[^ Zbgpz̍폜
				for(i = 0; i < nVertices; ++i)
					delete[] Indices[i];
			}
		}
		//_̃{[ EFCg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "VertexWeights"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//_̎擾
			UINT nVertices = atoi(str.c_str());
			if(nVertices)
			{
				//f[^ Zbgpz
				vector<float*> Weights(nVertices);
				for(UINT i = 0; i < nVertices; ++i)
					Weights[i] = new float[TA_MAX_VERTEX_BONE_COUNT];

				//_[v
				for(i = 0; i < nVertices; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//{[ EFCg̎擾
					sscanf(str.c_str(), "%f,%f,%f,%f", &Weights[i][0], &Weights[i][1], &Weights[i][2], &Weights[i][3]);
				}

				//_̃{[ EFCgZbg
				pObject->SetVertexBones(NULL, &Weights.front());

				//f[^ Zbgpz̍폜
				for(i = 0; i < nVertices; ++i)
					delete[] Weights[i];
			}
		}
		//ʂ̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Faces"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ʐ̎擾
			UINT nFaces = atoi(str.c_str());
			if(nFaces)
			{
				//ʂ̒_CfbNX Xg
				vector<int*> Indices(nFaces);

				//ʂ̒_Xg
				vector<UINT> Counts(nFaces);

				//ʂ̃[v
				for(UINT i = 0; i < nFaces; ++i)
				{
					//̃g[N擾
					if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//ʂ̒_擾
					Counts[i] = atoi(str.c_str());
					if(Counts[i])
					{
						//f[^ Zbgpz쐬
						Indices[i] = new int[Counts[i]];
						for(UINT j = 0; j < Counts[i]; ++j)
						{
							//̃g[N擾
							if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//_CfbNX̎擾
							Indices[i][j] = atoi(str.c_str());
						}
					}
					else
						Indices[i] = NULL;
				}

				//ʂ̍쐬
				pObject->AddFaces(&Indices.front(), &Counts.front(), nFaces);

				//f[^ Zbgpz폜
				for(i = 0; i < nFaces; ++i)
					if(Indices[i])
						delete[] Indices[i];
			}
		}
		//ʂ̃}eAQƂ̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "FaceMaterials"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ʐ̎擾
			UINT nFaces = atoi(str.c_str());
			if(nFaces)
			{
				//êڂă[g f擾
				//ToyStudio̢V[ɃC|[gR}h̏ꍇA
				//ǂݍݐ̃[g fCTaScane::GetRootModel()
				//Ŏ擾ł̂Ƃ͈Ⴄ̂CTaScene擾ȂB
				CTaObject* pRoot = pObject->GetRootModel();

				//}eA Xg擾
				vector<CTaMaterial*> Materials(pRoot->GetModelMaterialCount());
				pRoot->GetModelMaterials(&Materials.front());

				//ʂ̃}eAQƃXg
				vector<CTaMaterial*> FaceMaterials(nFaces);

				//ʂ̃[v
				for(UINT i = 0; i < nFaces; ++i)
				{
					//̃g[N擾
					if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//}eÃCfbNX擾
					int nIndex = atoi(str.c_str());

					//}eA擾
					if(nIndex != -1)
						FaceMaterials[i] = Materials[nIndex];
					else
						FaceMaterials[i] = NULL;
				}

				//ʂ̃}eAQƂZbg
				pObject->SetFaceMaterials(&FaceMaterials.front());
			}
		}
		//ʂ̒_̃tbg VF[fBO tȌꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "FlatShades"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ʐ擾
			UINT nFaces = atoi(str.c_str());
			if(nFaces)
			{
				//ʂ̒_̃tbg VF[fBOpXg
				vector<BOOL*> FlatShades(nFaces);

				//ʂ̒_Xg
				vector<UINT> Counts(nFaces);

				//ʂ̃[v
				for(UINT i = 0; i < nFaces; ++i)
				{
					//̃g[N擾
					if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//ʂ̒_擾
					Counts[i] = atoi(str.c_str());
					if(Counts[i])
					{
						//f[^ Zbgpz쐬
						FlatShades[i] = new BOOL[Counts[i]];
						for(UINT j = 0; j < Counts[i]; ++j)
						{
							//̃g[N擾
							if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//tbg VF[fBO tO擾
							FlatShades[i][j] = atoi(str.c_str());
						}
					}
					else
						FlatShades[i] = NULL;
				}

				//ʂ̃tbg VF[fBO tOZbg
				pObject->SetFaceVertexFlatShades(&FlatShades.front());

				//f[^ Zbgpz̍폜
				for(i = 0; i < nFaces; ++i)
					if(FlatShades[i])
						delete[] FlatShades[i];
			}
		}
		//ʂ̒_UVꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "UVs"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ʐ̎擾
			UINT nFaces = atoi(str.c_str());
			if(nFaces)
			{
				//ʂ̒_UVXg
				vector<TA_VECTOR_2D*> UVs(nFaces);

				//ʂ̒_Xg
				vector<UINT> Counts(nFaces);

				//ʂ̃[v
				for(UINT i = 0; i < nFaces; ++i)
				{
					//̃g[N擾
					if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//ʂ̒_擾
					Counts[i] = atoi(str.c_str());
					if(Counts[i])
					{
						//f[^ Zbgpz쐬
						UVs[i] = new TA_VECTOR_2D[Counts[i]];
						for(UINT j = 0; j < Counts[i]; ++j)
						{
							//̃g[N擾
							if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//UWl̎擾
							UVs[i][j].u = atof(str.c_str());

							//̃g[N擾
							if(!GET_NEXT_TOKEN_DLM(strFile, nStartPos, nEndPos, ", \t\r\n{"))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//VWl̎擾
							UVs[i][j].v = atof(str.c_str());
						}
					}
					else
						UVs[i] = NULL;
				}

				//ʂ̒_UVZbg
				pObject->SetFaceVertexUVs(&UVs.front());

				//f[^ Zbgpz폜
				for(i = 0; i < nFaces; ++i)
					if(UVs[i])
						delete[] UVs[i];
			}
		}
		//{[ Xg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Bones"))
		{
			//{[ǉ
			pBoneInfo = new BONE_INFO;
			BoneInfos.push_back(pBoneInfo);

			//̃IuWFNgXLƂăZbg
			pBoneInfo->pSkin = pObject;

			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//IuWFNg̏ꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Object"))
				{
					//̃g[N̎擾
					while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
					{
						//Kw̏ꍇ
						if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TreeName"))
						{
							//̃g[N̎擾
							if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//{[̊Kw擾
							pBoneInfo->BoneNames.push_back(str);
						}
						//I^Ȍꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
							break;
					}
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//XL̃oChϊs̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "SkinBindTransform"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//ϊs̎擾
			TA_MATRIX& mat = pBoneInfo->SkinBindTransform;
			sscanf(str.c_str(), "%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f",
				&mat.m[0][0], &mat.m[0][1], &mat.m[0][2], &mat.m[0][3],
				&mat.m[1][0], &mat.m[1][1], &mat.m[1][2], &mat.m[1][3],
				&mat.m[2][0], &mat.m[2][1], &mat.m[2][2], &mat.m[2][3],
				&mat.m[3][0], &mat.m[3][1], &mat.m[3][2], &mat.m[3][3]);
		}
		//{[̃oChϊs񃊃Xg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "BoneBindTransforms"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//{[擾
			UINT nBones = atoi(str.c_str());
			if(nBones)
			{
				//s񃊃XgTCY
				vector<TA_MATRIX>& matrices = pBoneInfo->BoneBindTransforms;
				matrices.resize(nBones);

				//{[ [v
				for(UINT i = 0; i < nBones; ++i)
				{
					//̃g[N̎擾
					if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
						return;

					//̎擾
					str = strFile.substr(nStartPos, nEndPos-nStartPos);

					//ϊs̎擾
					TA_MATRIX& mat = matrices[i];
					sscanf(str.c_str(), "%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f,%f",
						&mat.m[0][0], &mat.m[0][1], &mat.m[0][2], &mat.m[0][3],
						&mat.m[1][0], &mat.m[1][1], &mat.m[1][2], &mat.m[1][3],
						&mat.m[2][0], &mat.m[2][1], &mat.m[2][2], &mat.m[2][3],
						&mat.m[3][0], &mat.m[3][1], &mat.m[3][2], &mat.m[3][3]);
				}
			}
		}
		//oCh |[Y̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "BindPose"))
		{
			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//IuWFNg̏ꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Object"))
				{
					//̃g[N̎擾
					while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
					{
						//Kw̏ꍇ
						if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "TreeName"))
						{
							//̃g[N̎擾
							if(!GET_NEXT_NAME(strFile, nStartPos, nEndPos))
								return;

							//̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);

							//Kw̎擾
							pBoneInfo->BindPoseObjectNames.push_back(str);
						}
						//IuWFNg̃p[^̏ꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Params"))
						{
							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//ړ̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);
							sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
							pBoneInfo->BindPoseTranslates.push_back(vec);

							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//]̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);
							sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
							pBoneInfo->BindPoseAngles.push_back(vec);

							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//XP[̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);
							sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
							pBoneInfo->BindPoseScales.push_back(vec);

							//̃g[N̎擾
							if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
								return;

							//f̎擾
							str = strFile.substr(nStartPos, nEndPos-nStartPos);
							sscanf(str.c_str(), "%f,%f,%f", &vec.x, &vec.y, &vec.z);
							pBoneInfo->BindPoseShears.push_back(vec);
						}
						//I^Ȍꍇ
						else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
							break;
					}
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//WCg̉e͈̗͂LԂ̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "JointAreaEnabled"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//WCg̉e͈̗͂LԂ̃Zbg
			pObject->SetJointAreaEnabled(atoi(str.c_str()) != 0);
		}
		//J̎ˉe^Cv̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CameraProjectionType"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//J̎ˉe^CṽZbg
			pObject->SetCameraProjectionType(static_cast<TA_PROJECTION_TYPE>(atoi(str.c_str())));
		}
		//JYp̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CameraViewAngle"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//JYp̃Zbg
			pObject->SetCameraViewAngle(atof(str.c_str()));
		}
		//J̎썂̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CameraViewHeight"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//J̎썂̃Zbg
			pObject->SetCameraViewHeight(atof(str.c_str()));
		}
		//Cg̃J[̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightColor"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̃J[̃Zbg
			sscanf(str.c_str(), "%f,%f,%f", &vec.r, &vec.g, &vec.b);
			pObject->SetLightColor(vec);
		}
		//Cg̊gȔꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightDiffuse"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̊gŨZbg
			pObject->SetLightDiffuse(atof(str.c_str()));
		}
		//Cg̊̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightAmbient"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̊̃Zbg
			pObject->SetLightAmbient(atof(str.c_str()));
		}
		//Cg̔ˌ̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightSpecular"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̔ˌ̃Zbg
			pObject->SetLightSpecular(atof(str.c_str()));
		}
		//Cg ^Cv̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightType"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg ^CṽZbg
			pObject->SetLightType(static_cast<TA_LIGHT_TYPE>(atoi(str.c_str())));
		}
		//Cg̋x̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightIntensity"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̋x̃Zbg
			pObject->SetLightIntensity(atof(str.c_str()));
		}
		//Cg̉~px̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightConeAngle"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̉~px̃Zbg
			pObject->SetLightConeAngle(atof(str.c_str()));
		}
		//Cg̎ӕpx̏ꍇ(o[W1.6.1.3Œǉ)
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "LightPenumbraAngle"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//Cg̎ӕpx̃Zbg
			pObject->SetLightPenumbraAngle(atof(str.c_str()));
		}
		//Aj[V Xg̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Anims"))
		{
			//̃g[N̎擾
			while(GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
			{
				//Aj[V̏ꍇ
				if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "Anim"))
				{
					//Aj[V̍쐬
					CTaAnim* pAnim = TaCreateAnim();
					pObject->AddModelAnim(pAnim);

					//Aj[V f[^̓ǂݍ
					ReadAnim(strFile, nStartPos, nEndPos, pObject, pAnim, bMatrix);
				}
				//I^Ȍꍇ
				else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
					break;
			}
		}
		//݂̃Aj[V̏ꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "CurAnim"))
		{
			//̃g[N̎擾
			if(!GET_NEXT_TOKEN(strFile, nStartPos, nEndPos))
				return;

			//̎擾
			str = strFile.substr(nStartPos, nEndPos-nStartPos);

			//݂̃Aj[VZbg
			pObject->SetModelCurAnim(pObject->GetModelAnim(atoi(str.c_str())));
		}
		//I^Ȍꍇ
		else if(COMPARE_TOKEN(strFile, nStartPos, nEndPos, "}"))
		{
			//IuWFNg̃^CvbVWCg̏ꍇ
			if(pObject->GetType() == TA_OBJECT_MESH || pObject->GetType() == TA_OBJECT_JOINT)
			{
				//sȃ|S f[^폜
				pObject->CleanUpMesh();

				//|S̐ڑ֌W̍XV
				pObject->UpdateMeshTopology();

				//|S̖@xNg̍XV
				pObject->UpdateMeshNormals();
			}
			
			//oEfBO {bNX̍XV
			pObject->UpdateBoundBox();

			//OtBbNX̍XV
			pObject->UpdateGraphics();

			return;
		}
	}
}

//eLXg t@C̓ǂݍ
/*
pszFilePath		t@C̃tpXB
pScene			V[B
pRootModel		[g fB
bMatrix			TRUȄꍇAAj[VIuWFNg̕ϊsœǂݍށB
*/
BOOL ReadTextFile(LPCTSTR pszFilePath, CTaScene* pScene, CTaObject* pRootModel, BOOL bMatrix)
{
	//t@CJ
	HANDLE hFile = CreateFile(pszFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
	if(hFile == INVALID_HANDLE_VALUE)
		return FALSE;

	//TCY `FbN
	DWORD dwSize = ::GetFileSize(hFile, NULL);
	if(!dwSize)
	{
		CloseHandle(hFile);
		return FALSE;
	}

	//t@Cǂݍݗp
	string strFile;
	strFile.resize(dwSize);

	//Ƀf[^ǂݍ
	DWORD dwBytes;
	if(!::ReadFile(hFile, &strFile[0], dwSize, &dwBytes, 0))
	{
		CloseHandle(hFile);
		return FALSE;
	}

	//t@C
	CloseHandle(hFile);

	//g[ÑX^[gAGhʒu
	size_t nStartPos = 0;
	size_t nEndPos   = 0;

	//̃^OV[Ȃꍇ
	if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Scene"))
		return FALSE;

	//̃^OIuWFNgȂꍇ
	if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Object"))
		return FALSE;

	//̃^O^CvȂꍇ
	if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Type"))
		return FALSE;

	//[g IuWFNg̃^CvfȂꍇ
	if(!CHECK_NEXT_TOKEN(strFile, nStartPos, nEndPos, "Model"))
		return FALSE;

	//{[̃Xg
	vector<BONE_INFO*> BoneInfos;

	//[g fǂݍ
	ReadObject(strFile, nStartPos, nEndPos, pScene, pRootModel, BoneInfos, bMatrix);

	//SẴIuWFNg쐬ꂽłȂƁA
	//KwɂQƂ͂łȂ̂ŒӁB

	//{[̃[v
	for(UINT i = 0; i < BoneInfos.size(); ++i)
	{
		//{[̎擾
		BONE_INFO* pBoneInfo = BoneInfos[i];

		//XL IuWFNg擾
		CTaObject* pSkin = pBoneInfo->pSkin;

		//Kw{[ Xg擾
		vector<CTaObject*> Bones;
		for(UINT j = 0; j < pBoneInfo->BoneNames.size(); ++j)
			Bones.push_back(pRootModel->FindTreeName(pBoneInfo->BoneNames[j].c_str()));

		//1.{[ XgZbg
		pSkin->SetBones(&Bones.front(), Bones.size());

		//2.XL̃oChϊsZbg
		pSkin->SetSkinBindTransform(pBoneInfo->SkinBindTransform);

		//3.{[̃oChϊsZbg
		pSkin->SetBoneBindTransforms(&pBoneInfo->BoneBindTransforms.front(), Bones.size());

		//KwoCh |[ỸIuWFNg Xg擾
		vector<CTaObject*> BindPoseObjects;
		for(j = 0; j < pBoneInfo->BindPoseObjectNames.size(); ++j)
			BindPoseObjects.push_back(pRootModel->FindTreeName(pBoneInfo->BindPoseObjectNames[j].c_str()));

		//4.oCh |[YZbg
		pSkin->SetBindPose(&BindPoseObjects.front(),
			&pBoneInfo->BindPoseTranslates.front(), &pBoneInfo->BindPoseAngles.front(), 
			&pBoneInfo->BindPoseScales.front(), &pBoneInfo->BindPoseShears.front(),
			BindPoseObjects.size());

		//XLjOs߂ɂ́A_̃{[ CfbNXAEFCg
		//ɉāA1`4̏񂪕KvłB

		//OtBbNX̍XV
		pSkin->UpdateGraphics();

		//{[̍폜
		delete pBoneInfo;
	}

	return TRUE;
}
