#pragma once

//ToyStudio APICũCN[h
#include "TaLib.h"

/**
\file TaPlugin.h
\brief vOC쐬p̃wb_[t@CłB
*/

///C|[gvf̊֐gȂꍇARgAEgĂB
#define USE_IMPORT_FUNC

///GNX|[gvf̊֐gȂꍇARgAEgĂB
#define USE_EXPORT_FUNC

/**
\addtogroup NecessaryFuncGroup
*/
//@{ 

///ToyStudio SDK̃o[W擾
/**
\param pVersionMS #TA_SDK_VERSION_MS Ԃ܂B
\param pVersionLS #TA_SDK_VERSION_LS Ԃ܂B
*/
TA_PLUGIN_EXPORT void TaGetSdkVersion(DWORD* pVersionMS, DWORD* pVersionLS);

///vOC̖O擾
/**
\return vOC̖OB
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetProductName();

///vOC̃o[W擾
/**
\return vOC̃o[WpB
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetProductVersion();

///vOC̊JҖ擾
/**
\return vOC̊JҖB
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetManufacturerName();

///vOC̋@\vftO擾
/**
\return #TA_PLUGIN_ELEMENT_IMPORT#TA_PLUGIN_ELEMENT_EXPORTORŎw肵܂B
*/
TA_PLUGIN_EXPORT UINT TaGetPluginElements();

///vOC̏
/** ֐ TaInitLib() Ăяo܂B
\param hModule vOČĂяõW[nhB
\return ɐꍇATRUEԂ܂B
*/
TA_PLUGIN_EXPORT BOOL TaInitPlugin(HMODULE hModule);

//@}


#ifdef USE_IMPORT_FUNC

/**
\addtogroup ImportFuncGroup
*/
//@{

///C|[g t@C̃^Cv擾
/**
\return C|[g t@C̃^CvB
*/
TA_PLUGIN_EXPORT UINT TaGetImportFileTypeCount();

///C|[g t@C̃^Cv擾
/**
\param nIndex t@C ^CṽCfbNXB
\return t@C ^CvB"eLXg t@C (*.txt)"̌`B
*/
//
TA_PLUGIN_EXPORT LPCTSTR TaGetImportFileType(UINT nIndex);

///C|[g t@C̊gq擾
/**
\param nIndex t@C ^CṽCfbNXB
\return t@C̊gqB".txt"̌`B
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetImportFileExt(UINT nIndex);

///t@C̃C|[g
/**
ʏ̃t@C C|[gł CTaScene::GetRootModel() ̒lpRootModel͈v܂B
̃V[ɃC|[gꍇ́AꎞIȃf쐬pModelɃZbgA
ǂݍݏIɖ{̂̃f[^Ƀ}[Ŵňv܂B
\param nIndex t@C ^CṽCfbNXB
\param pszFilePath t@C̃tpXB
\param pScene ǂݍݐ̃V[B
\param pRootModel  ǂݍݐ̃[g f(#TA_OBJECT_MODEL ^CṽIuWFNg)B
\return ǂݍ݂ꍇATRUEԂ܂B
*/
TA_PLUGIN_EXPORT BOOL TaImportFile(UINT nIndex, LPCTSTR pszFilePath, CTaScene* pScene, CTaObject* pRootModel);

//@}

#endif

#ifdef USE_EXPORT_FUNC

/**
\addtogroup ExportFuncGroup
*/
//@{ 

///GNX|[g t@C̃^Cv擾
/**
\return GNX|[g t@C̃^CvB
*/
TA_PLUGIN_EXPORT UINT TaGetExportFileTypeCount();

///GNX|[g t@C̃^Cv擾
/**
\param nIndex t@C ^CṽCfbNXB
\return t@C ^CvB"eLXg t@C (*.txt)"̌`B
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetExportFileType(UINT nIndex);

///GNX|[g t@C̊gq擾
/**
\param nIndex t@C ^CṽCfbNXB
\return t@C̊gqB".txt"̌`B
*/
TA_PLUGIN_EXPORT LPCTSTR TaGetExportFileExt(UINT nIndex);

///t@C̃GNX|[g
/**
֐ŃV[̃f[^ꎞIɕύXꍇ́A
KĂKv܂B
\param nIndex t@C ^CṽCfbNXB
\param pszFilePath t@C̃tpXB
\param pScene ǂݍ݌̃V[B
\return oꍇATRUEԂ܂B
*/
TA_PLUGIN_EXPORT BOOL TaExportFile(UINT nIndex, LPCTSTR pszFilePath, CTaScene* pScene);

//@}

#endif
